<?php
/**
 * @package	JoomSMS for Joomla!
 * @version	1.0
* @author	joomboost.com
 * @copyright	(C) 2013-2020 JoomBoost. All rights reserved.
 * @license	GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php

class AnswerTriggerController extends JOOMSMSController{

	var $pkey = 'answertrigger_id';
	var $table = 'answertrigger';
	var $orderingColumnName = 'answertrigger_ordering';
	var $aclCat = 'answers_trigger';

	function copy(){
		JRequest::checkToken() or die('Invalid Token');
		if(!$this->isAllowed('answers_trigger', 'copy')) return;


		$db = JFactory::getDBO();
		$cids = JRequest::getVar('cid', array(), '', 'array');
		if(empty($cids)) return $this->listing();
		foreach($cids as $oneId){
			$query = 'INSERT INTO `#__joomsms_answertrigger` (`answertrigger_name`, `answertrigger_description`,`answertrigger_actions`,`answertrigger_triggers`,`answertrigger_publish`)';
			$query .= " SELECT CONCAT('copy_',`answertrigger_name`),`answertrigger_description`,`answertrigger_actions`,`answertrigger_triggers`,`answertrigger_publish` FROM `#__joomsms_answertrigger` WHERE `answertrigger_id` = ".intval($oneId);
			$db->setQuery($query);
			$db->query();
		}
		return $this->listing();
	}

	function store(){
		JRequest::checkToken() or die('Invalid Token');
		if(!$this->isAllowed('answers_trigger', 'manage')) return;

		$answerTriggerClass = JOOMSMS::get('class.answertrigger');

		$status = $answerTriggerClass->saveForm();
		if($status){
			JOOMSMS::enqueueMessage(JText::_('SMS_SUCC_SAVED'), 'message');
		}else{
			JOOMSMS::enqueueMessage(JText::_('SMS_ERROR_SAVING'), 'error');
			if(!empty($answerTriggerClass->errors)){
				foreach($categoryClass->errors as $oneError){
					JOOMSMS::enqueueMessage($oneError, 'error');
				}
			}
		}
	}

	function remove(){
		JRequest::checkToken() or die('Invalid Token');
		if(!$this->isAllowed('answers_trigger', 'delete')) return;

		$answerTriggerClass = JOOMSMS::get('class.answertrigger');

		$cids = JRequest::getVar('cid', array(), '', 'array');
		if(empty($cids)) return $this->listing();
		$num = $answerTriggerClass->delete($cids);
		JOOMSMS::enqueueMessage(JText::sprintf('SMS_SUCC_DELETE_ELEMENTS', $num), 'message');

		return $this->listing();
	}
}
