<?php
/**
 * @package	JoomSMS for Joomla!
 * @version	1.0
* @author	joomboost.com
 * @copyright	(C) 2013-2020 JoomBoost. All rights reserved.
 * @license	GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php

class FieldsController extends joomsmsController{
	var $pkey = 'fields_fieldid';
	var $table = 'fields';
	var $orderingColumnName = 'fields_ordering';
	var $groupMap = '';
	var $groupVal = '';

	function store(){
		JRequest::checkToken() or die('Invalid Token');
		if(!$this->isAllowed('configuration', 'manage')) return;

		$class = JOOMSMS::get('class.fields');
		$status = $class->saveForm();
		if($status){
			JOOMSMS::enqueueMessage(JText::_('SMS_SUCC_SAVED'), 'message');
		}else{
			JOOMSMS::enqueueMessage(JText::_('SMS_ERROR_SAVING'), 'error');
			if(!empty($class->errors)){
				foreach($class->errors as $oneError){
					JOOMSMS::enqueueMessage($oneError, 'error');
				}
			}
		}
	}

	function remove(){
		JRequest::checkToken() or die('Invalid Token');
		if(!$this->isAllowed('configuration', 'manage')) return;

		$cids = JRequest::getVar('cid', array(), '', 'array');

		$class = JOOMSMS::get('class.fields');
		$num = $class->delete($cids);

		if($num){
			JOOMSMS::enqueueMessage(JText::sprintf('SMS_SUCC_DELETE_ELEMENTS', $num), 'message');
		}

		return $this->listing();
	}

	function choose(){
		if(!$this->isAllowed('configuration', 'manage')) return;
		JRequest::setVar('layout', 'choose');
		return parent::display();
	}

}
