<?php
/**
 * @package	JoomSMS for Joomla!
 * @version	1.0
 * @author	joomboost.com
 * @copyright	(C) 2013-2020 JoomBoost. All rights reserved.
 * @license	GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?>
<?php

class FileController extends JOOMSMSController{
	function language(){
		JRequest::setVar('layout', 'language');
		return parent::display();
	}

	function save(){
		JRequest::checkToken() or die('Invalid Token');
		$this->_savelanguage();
		return $this->language();
	}

	function savecss(){
		JRequest::checkToken() or die('Invalid Token');
		if(!$this->isAllowed('configuration', 'manage')) return;

		$file = JRequest::getCmd('file');
		if(!preg_match('#^([-a-z0-9]*)_([-_a-z0-9]*)$#i', $file, $result)){
			JOOMSMS::enqueueMessage('Could not load the file '.$file.' properly');
			exit;
		}
		$type = $result[1];
		$fileName = $result[2];
		jimport('joomla.filesystem.file');
		$path = JOOMSMS_MEDIA.'css'.DS.$type.'_'.$fileName.'.css';
		$csscontent = JRequest::getString('csscontent');
		$alreadyExists = file_exists($path);
		if(JFile::write($path, $csscontent)){
			JOOMSMS::enqueueMessage(JText::_('SMS_SUCC_SAVED'), 'success');
			$varName = JRequest::getCmd('var');
			if(!$alreadyExists){
				$js = "var optn = document.createElement(\"OPTION\");
						optn.text = '$fileName'; optn.value = '$fileName';
						mydrop = window.top.document.getElementById('".$varName."_choice');
						mydrop.options.add(optn);
						lastid = 0; while(mydrop.options[lastid+1]){lastid = lastid+1;} mydrop.selectedIndex = lastid;
						window.top.updateCSSLink('".$varName."','$type','$fileName');";
				$doc = JFactory::getDocument();
				$doc->addScriptDeclaration($js);
			}
			$config = JOOMSMS::config();
			$newConfig = new stdClass();
			$newConfig->$varName = $fileName;
			$config->save($newConfig);
		}else{
			JOOMSMS::enqueueMessage(JText::sprintf('SMS_FAIL_SAVE', $path), 'error');
		}
		return $this->css();
	}

	function css(){
		JRequest::setVar('layout', 'css');
		return parent::display();
	}

	function latest(){
		return $this->language();
	}

	function share(){
		JRequest::checkToken() or die('Invalid Token');
		if(!$this->isAllowed('configuration', 'manage')) return;
		if($this->_savelanguage()){
			JRequest::setVar('layout', 'share');
			return parent::display();
		}else{
			return $this->language();
		}
	}

	function send(){
		JRequest::checkToken() or die('Invalid Token');
		if(!$this->isAllowed('configuration', 'manage')) return;

		$bodyMessage = JRequest::getString('msgbody');
		$config = JOOMSMS::config();
		$code = JRequest::getString('code');
		JRequest::setVar('code', $code);
		if(empty($code)) return;
		$mailer = JFactory::getMailer();
		$mailer->isHTML(true);
		$user = JFactory::getUser();
		$sender = array($user->email, $user->username);
		$mailer->setSender($sender);
		$mailer->addRecipient(array('translate@joomboost.com', $user->email));
		$subject = '[JOOMSMS LANGUAGE FILE] '.$code;
		$mailer->setSubject($subject);
		$body = 'The website '.JOOMSMS_LIVE.' using JoomSMS '.$config->get('version').' sent a language file : '.$code;
		$body .= "\n"."\n"."\n".$bodyMessage;

		$extrafile = JLanguage::getLanguagePath(JPATH_ROOT).DS.$code.DS.$code.'.com_joomsms_custom.ini';

		if(file_exists($extrafile)){
			$mailer->Body .= "\n"."\n"."\n".'Custom content:'."\n".file_get_contents($extrafile);
		}

		$mailer->setBody($body);
		jimport('joomla.filesystem.file');
		$path = JPath::clean(JLanguage::getLanguagePath(JPATH_ROOT).DS.$code.DS.$code.'.com_joomsms.ini');
		$mailer->AddAttachment($path);
		$send = $mailer->Send();
		if($send == true){
			JOOMSMS::display(JText::_('SMS_THANK_YOU_SHARING'), 'success');
		}else{
			JOOMSMS::display(JText::_('SMS_ERROR_SENDING_LANGUAGE'), 'error');
		}
	}

	function _savelanguage(){
		if(!$this->isAllowed('configuration', 'manage')) return;

		jimport('joomla.filesystem.file');
		$code = JRequest::getString('code');
		JRequest::setVar('code', $code);
		$content = JRequest::getVar('content', '', '', 'string', JREQUEST_ALLOWHTML);
		if(empty($code) OR empty($content)) return;
		$path = JLanguage::getLanguagePath(JPATH_ROOT).DS.$code.DS.$code.'.com_joomsms.ini';
		$result = JFile::write($path, $content);
		if($result){
			JOOMSMS::enqueueMessage(JText::_('SMS_SUCC_SAVED'), 'success');
			$js = "window.top.document.getElementById('image$code').className = 'joomsmsicon-edit'";
			$doc = JFactory::getDocument();
			$doc->addScriptDeclaration($js);

		}else{
			JOOMSMS::enqueueMessage(JText::sprintf('SMS_FAIL_SAVE', $path), 'error');
		}
		$customcontent = JRequest::getVar('customcontent', '', '', 'string', JREQUEST_ALLOWHTML);
		$custompath = JLanguage::getLanguagePath(JPATH_ROOT).DS.$code.DS.$code.'.com_joomsms_custom.ini';
		$customresult = JFile::write($custompath, $customcontent);
		if(!$customresult) JOOMSMS::enqueueMessage(JText::sprintf('SMS_FAIL_SAVE', $custompath), 'error');

		return $result;
	}

}
