<?php
/**
 * @package	JoomSMS for Joomla!
 * @version	1.0
* @author	joomboost.com
 * @copyright	(C) 2013-2020 JoomBoost. All rights reserved.
 * @license	GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php

class SenderprofileController extends JOOMSMSController{

	var $aclCat = 'sender_profiles';

	function copy(){
		JRequest::checkToken() or die('Invalid Token');
		if(!$this->isAllowed('sender_profiles', 'copy')) return;

		$cids = JRequest::getVar('cid', array(), '', 'array');
		$db = JFactory::getDBO();

		$my = JFactory::getUser();
		$creatorId = intval($my->id);

		foreach($cids as $oneSenderProfileid){
			$query = 'INSERT INTO `#__joomsms_senderprofile` (`senderprofile_name`,`senderprofile_gateway`,`senderprofile_userid`,`senderprofile_params`)';
			$query .= " SELECT CONCAT('copy_',`senderprofile_name`), `senderprofile_gateway`,".intval($creatorId).",`senderprofile_params`  FROM `#__joomsms_senderprofile` WHERE `senderprofile_id` = ".intval($oneSenderProfileid);
			$db->setQuery($query);
			$db->query();
		}

		return $this->listing();
	}

	function gatewayparams(){
		$gateway = JRequest::getCmd('gateway');

		if(!empty($gateway)){
			$class = JOOMSMS::get('class.senderprofile');
			$gateway = $class->getGateway($gateway);
			$gateway->displayConfig();
		}
		exit;
	}

	function store(){
		JRequest::checkToken() or die('Invalid Token');
		if(!$this->isAllowed('sender_profiles', 'manage')) return;

		$class = JOOMSMS::get('class.senderprofile');

		$status = $class->saveForm();
		if($status){
			JOOMSMS::enqueueMessage(JText::_('SMS_SUCC_SAVED'), 'message');
		}else{
			JOOMSMS::enqueueMessage(JText::_('SMS_ERROR_SAVING'), 'error');
			if(!empty($class->errors)){
				foreach($class->errors as $oneError){
					JOOMSMS::enqueueMessage($oneError, 'error');
				}
			}
		}
	}

	function sendtest(){
		if(!$this->isAllowed('sender_profiles', 'sendtest')) return;

		$senderprofileClass = JOOMSMS::get('class.senderprofile');
		$messageClass = JOOMSMS::get('class.message');

		$this->store();

		$gatewayId = JOOMSMS::getCID('senderprofile_id');

		if(empty($gatewayId)) return;
		$gateway = $senderprofileClass->getGateway($gatewayId);
		$message = new stdClass();
		$message->message_body = JRequest::getString('message_body');


		$messageClass->sendtest($message, $gateway);

		return $this->edit();
	}

	function remove(){
		JRequest::checkToken() or die('Invalid Token');
		if(!$this->isAllowed('sender_profiles', 'delete')) return;

		$cids = JRequest::getVar('cid', array(), '', 'array');
		$class = JOOMSMS::get('class.senderprofile');
		$num = $class->delete($cids);

		JOOMSMS::enqueueMessage(JText::sprintf('SMS_SUCC_DELETE_ELEMENTS', $num), 'message');

		return $this->listing();
	}

	function checkBalance(){
		$menuHelper = JOOMSMS::get('helper.menu');
		$myBalArea = $menuHelper->myBalanceArea();
		echo $myBalArea;
		exit;
	}
}
