<?php
/**
 * @package	JoomSMS for Joomla!
 * @version	1.0
* @author	joomboost.com
 * @copyright	(C) 2013-2020 JoomBoost. All rights reserved.
 * @license	GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php

class UserController extends JOOMSMSController{

	var $pkey = 'user_id';
	var $table = 'user';

	function store(){
		if(!$this->isAllowed('receivers', 'manage')) return;
		JRequest::checkToken() or die('Invalid Token');

		$userClass = JOOMSMS::get('class.user');
		$status = $userClass->saveForm();

		if($status){
			JOOMSMS::enqueueMessage(JText::_('SMS_SUCC_SAVED'), 'message');
		}else{
			JOOMSMS::enqueueMessage(JText::_('SMS_ERROR_SAVING'), 'error');
			if(!empty($userClass->errors)){
				foreach($userClass->errors as $oneError){
					JOOMSMS::enqueueMessage($oneError, 'error');
				}
			}
		}
	}

	function save(){
		$this->store();
		return $this->cancel();
	}

	function cancel(){
		$app = JFactory::getApplication();
		if($app->isAdmin()){
			$redirectURL = JOOMSMS::completeLink('receiver', false, true);
		}else $redirectURL = JOOMSMS::completeLink('frontreceiver', false, true);

		$this->setRedirect($redirectURL);
	}

	function choosejoomuser(){
		JHTML::_('behavior.modal', 'a.modal');
		JRequest::setVar('layout', 'choosejoomuser');
		return parent::display();
	}
}
