<?php
/**
 * @package	    JoomSMS for Joomla!
 * @version	    1.0
 * @author	    joomboost.com
 * @copyright	(C) 2013-2020 JoomBoost. All rights reserved.
 * @license	    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php
include_once(rtrim(JPATH_ADMINISTRATOR, DIRECTORY_SEPARATOR).DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_joomsms'.DIRECTORY_SEPARATOR.'helpers'.DIRECTORY_SEPARATOR.'helper.php');



JLoader::register('JoomsmsHelper', JPATH_COMPONENT_ADMINISTRATOR. '/helpers/joomsms.php');
JLoader::register('JoomsmsHelperVersion', JPATH_COMPONENT_ADMINISTRATOR. '/helpers/version.php');
//load admin css

JHtml::_('jquery.framework');
$document = JFactory::getDocument();
$document->addStyleSheet(JUri::root().'media/com_joomsms/css/admin.css');
$document->addStyleSheet(JUri::root() . 'media/com_joomsms/css/all.css');
$document->addStyleSheet(JUri::root().'media/com_joomsms/css/bootstrap.css');
$document->addScript(JUri::root().'media/com_joomsms/js/menuBuilder.js');
if(JComponentHelper::isEnabled('com_easyjobsmanager') && JPluginHelper::isEnabled('joomsms','easyjobsmanager')){
    $lang = JFactory::getLanguage();
    $lang->load('plg_joomsms_easyjobsmanager', JPATH_ADMINISTRATOR, 'en-GB', true);
}
// check system plugin
if(!JPluginHelper::isEnabled('system','joomsms')){
    \Joomla\CMS\Factory::getApplication()->enqueueMessage(JText::sprintf('COM_JOOMSMS_ENABLE_SYSTEM_PLUGIN',JSession::getFormToken() .'=1'),'warning');
}

if(defined('JDEBUG') AND JDEBUG) JOOMSMS::displayErrors();



$taskGroup = JRequest::getCmd('ctrl', 'dashboard');
$doc = JFactory::getDocument();
$app = JFactory::getApplication();
$config = JOOMSMS::config();
$doc->addStyleSheet(JOOMSMS_CSS.'component.css?v='.str_replace('.', '', $config->get('version')));
JHTML::_('behavior.tooltip');

$currentuser = JFactory::getUser();
if($taskGroup != 'update'  && !$currentuser->authorise('core.manage', 'com_joomsms')){
	return JError::raiseWarning(404, JText::_('JERROR_ALERTNOAUTHOR'));
}

$action = JRequest::getCmd('task', 'listing');
if(empty($action)){
	$action = JRequest::getCmd('defaulttask', 'listing');
	JRequest::setVar('task', $action);
}

if(($taskGroup == 'cpanel' || ($taskGroup == 'update' && $action == 'listing'))  && !$currentuser->authorise('core.admin', 'com_joomsms')){
	return JError::raiseWarning(404, JText::_('JERROR_ALERTNOAUTHOR'));
}

if(!include(JOOMSMS_CONTROLLER.$taskGroup.'.php')){
	$app->redirect('index.php?option=com_joomsms');
	return;
}
$doc->addScript(JOOMSMS_JS.'joomsms_compat.js');

$className = ucfirst($taskGroup).'Controller';
$classGroup = new $className();

JRequest::setVar('view', $classGroup->getName());
$classGroup->execute(JRequest::getCmd('task', 'listing'));
$classGroup->redirect();