<?php
/**
 * @package	JoomSMS for Joomla!
 * @version	1.0
* @author	joomboost.com
 * @copyright	(C) 2013-2020 JoomBoost. All rights reserved.
 * @license	GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php


class categoryViewcategory extends joomsmsView{
	var $ctrl = 'category';

	function display($tpl = null){
		$function = $this->getLayout();
		if(method_exists($this, $function)) $this->$function();

        // Add submenu
        JoomsmsHelper::addSubmenu();
        $this->addSidebar();

        parent::display($tpl);

    }

    protected function addSidebar()
    {
        $this->sidebar = JHtmlSidebar::render();
    }

    function listing(){

		$app = JFactory::getApplication();
		$pageInfo = new stdClass();
		$pageInfo->filter = new stdClass();
		$pageInfo->filter->order = new stdClass();
		$pageInfo->limit = new stdClass();
		$pageInfo->elements = new stdClass();
		$config = JOOMSMS::config();
		$db = JFactory::getDBO();



		$paramBase = JOOMSMS_COMPONENT.'.'.$this->getName();
		$pageInfo->limit->value = $app->getUserStateFromRequest($paramBase.'.list_limit', 'limit', $app->getCfg('list_limit'), 'int');
		$pageInfo->limit->start = $app->getUserStateFromRequest($paramBase.'.limitstart', 'limitstart', 0, 'int');
		$pageInfo->filter->order->value = $app->getUserStateFromRequest($paramBase.".filter_order", 'filter_order', 'a.category_ordering', 'cmd');
		$pageInfo->filter->order->dir = $app->getUserStateFromRequest($paramBase.".filter_order_Dir", 'filter_order_Dir', 'asc', 'word');
		$pageInfo->search = $app->getUserStateFromRequest($paramBase.".search", 'search', '', 'string');
		$pageInfo->search = JString::strtolower(trim($pageInfo->search));

		if($pageInfo->filter->order->dir != "asc") $pageInfo->filter->order->dir = 'desc';

		$searchMap = array('a.category_id', 'a.category_name', 'a.category_ordering');
		$filters = array();
		if(!empty($pageInfo->search)){
			$searchVal = '\'%'.joomsms_getEscaped($pageInfo->search, true).'%\'';
			$filters[] = implode(" LIKE $searchVal OR ", $searchMap)." LIKE $searchVal";
		}



		$query = 'SELECT '.implode(',', $searchMap).' FROM '.JOOMSMS::table('category').' as a';
		if(!empty($filters)) $query .= ' WHERE ('.implode(') AND (', $filters).')';
		if(!empty($pageInfo->filter->order->value)){
			$query .= ' ORDER BY '.$pageInfo->filter->order->value.' '.$pageInfo->filter->order->dir;
		}

		$db->setQuery($query, $pageInfo->limit->start, $pageInfo->limit->value);
		$rows = $db->loadObjectList();

		$queryCount = 'SELECT COUNT(a.category_id) FROM '.JOOMSMS::table('category').' as a';
		$db->setQuery($queryCount);
		$pageInfo->elements->total = $db->loadResult();
		$pageInfo->elements->page = count($rows);



		jimport('joomla.html.pagination');
		$pagination = new JPagination($pageInfo->elements->total, $pageInfo->limit->start, $pageInfo->limit->value);

		JToolbarHelper::title(JText::_('SMS_CATEGORIES'));
        JToolbarHelper::addNew('add');
        JToolbarHelper::editList('edit');
        if(JOOMSMS::isAllowed($config->get('acl_categories_copy', 'all'))) JToolbarHelper::custom('copy', 'copy','copy',JText::_('SMS_COPY'),true);
        if(JOOMSMS::isAllowed($config->get('acl_categories_delete', 'all'))) JToolbarHelper::deleteList();

		$order = new stdClass();
		$order->ordering = false;
		$order->orderUp = 'orderup';
		$order->orderDown = 'orderdown';
		$order->reverse = false;
		if($pageInfo->filter->order->value == 'a.category_ordering'){
			$order->ordering = true;
			if($pageInfo->filter->order->dir == 'desc'){
				$order->orderUp = 'orderdown';
				$order->orderDown = 'orderup';
				$order->reverse = true;
			}
		}

		$this->assignRef('rows', $rows);
		$this->assignRef('order', $order);
		$this->assignRef('pageInfo', $pageInfo);
		$this->assignRef('pagination', $pagination);
		$this->assignRef('config', $config);
	}

	function form(){
		$categoryid = JOOMSMS::getCID('category_id');
		$config = JOOMSMS::config();

		if(!empty($categoryid)){
			$categoryClass = JOOMSMS::get('class.category');
			$category = $categoryClass->get($categoryid);
		}else{
			$category = new stdClass();
			$category->category_name = '';
		}

		JToolbarHelper::title(JText::_('SMS_CATEGORIES'));
        JToolbarHelper::apply('apply');
        JToolbarHelper::save('save');
        JToolbarHelper::cancel('cancel');


		$tabs = JOOMSMS::get('helper.tabs');
		$tabs->setOptions(array('useCookie' => true));
		$this->assignRef('tabs', $tabs);

		if(version_compare(JVERSION, '1.6.0', '<')){
			$script = 'function submitbutton(pressbutton){
						if (pressbutton == \'cancel\') {
							submitform( pressbutton );
							return;
						}';
		}else{
			$script = 'Joomla.submitbutton = function(pressbutton) {
						if (pressbutton == \'cancel\') {
							Joomla.submitform(pressbutton,document.adminForm);
							return;
						}';
		}
		$script .= 'if(window.document.getElementById("category_name").value.length < 2){alert(\''.JText::_('SMS_ENTER_NAME', true).'\'); return false;}';
		if(version_compare(JVERSION, '1.6.0', '<')){
			$script .= 'submitform( pressbutton );} ';
		}else{
			$script .= 'Joomla.submitform(pressbutton,document.adminForm);}; ';
		}

		$doc = JFactory::getDocument();
		$doc->addScriptDeclaration($script);
		$this->assignRef('category', $category);
		$this->assignRef('config', $config);
	}
}
