<?php
/**
 * @package            JoomSMS
 * @copyright          Copyright (C) 2013-2020 JoomBoost., Ltd. All Rights Reserved.
 * @license            GNU General Public License version 2 or later; see LICENSE.txt
 * @author             JoomBoost
 * @website            https://www.joomboost.com
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

jimport('joomla.application.component.view');

JLoader::register('JoomsmsHelperDashboard', JPATH_ADMINISTRATOR . '/components/com_joomsms/helpers/dashboard.php');



class dashboardViewDashboard extends JViewLegacy
{

    protected $stats;


    function display($tpl = null)
    {

        $this->modules = JFactory::getDocument()->loadRenderer('modules');

        $this->downloadid = JComponentHelper::getParams('com_joomsms')->get('downloadid', '');

        $document = JFactory::getDocument();
        $document->addStyleSheet(JUri::root().'media/com_joomsms/css/bootstrapfix.css');

        // get sidebar
        JoomsmsHelper::addSubmenu('dashboard');
        $this->sidebar = JHtmlSidebar::render();

        // get toolbar
        $this->addToolbar();

        // display view
        parent::display($tpl);
    }

    protected function compareVersion($newv, $oldv)
    {
        if (version_compare($oldv, $newv, '<')) {
            return true;
        }

        return false;
    }

    public function addToolbar()
    {

        $user = JFactory::getUser();

        if (
            $user->authorise('core.admin', 'com_joomsms') ||
            $user->authorise('core.options', 'com_joomsms')
        )
        {
            JToolbarHelper::preferences('com_joomsms');
        }


        JToolBarHelper::title('<i class="fas fa-tachometer-alt"></i> ' .JText::_('COM_JOOMSMS_DASHBOARD'));
        JToolbarHelper::help(null, null, 'https://www.joomboost.com/support/documentation/141-joomsms-documentation.html', 'com_joomsms');

        JToolBarHelper::addNew('addReceiver',JText::_('COM_JOOMSMS_ADD_RECEIVER'));
        JToolBarHelper::addNew('addMessage',JText::_('COM_JOOMSMS_ADD_MESSAGE'));
        JToolBarHelper::addNew('addCustomer',JText::_('COM_JOOMSMS_ADD_CUSTOMER'));

    }
}