<?php
/**
 * @package	JoomSMS for Joomla!
 * @version	1.0
* @author	joomboost.com
 * @copyright	(C) 2013-2020 JoomBoost. All rights reserved.
 * @license	GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?>
<?php if (!empty($this->sidebar)): ?>
<div id="j-sidebar-container" class="span2">
    <?php echo $this->sidebar; ?>
</div>
<div id="j-main-container" class="span10">
    <?php else : ?>
    <div id="j-main-container">
        <?php endif; ?>
        <div class="row-fluid span12">

<div id="joomsms_content">
	<div id="iframedoc"></div>

	<?php
		$saveOrderingUrl = 'index.php?option=com_joomsms&task=saveorder&tmpl=component';
		JHtml::_('sortablelist.sortable', 'fieldslisting', 'adminForm', 'asc', $saveOrderingUrl);

	?>
	<form action="index.php?option=<?php echo JOOMSMS_COMPONENT ?>&amp;ctrl=fields" method="post" name="adminForm" id="adminForm">
		<table class="table table-striped" id="fieldslisting">
			<thead>
			<tr>
				<th class="title titlenum">
					<?php echo JText::_('SMS_NUM'); ?>
				</th>
					<th width="1%" class="title titleorder">
						<?php echo '<i class="icon-menu-2"></i>'; ?>
					</th>
				<th class="title titlebox">
					<input type="checkbox" name="toggle" value="" onclick="joomsms_js.checkAll(this);"/>
				</th>
				<th class="title titlecolumn">
					<?php echo JText::_('SMS_FIELD_COLUMN'); ?>
				</th>
				<th class="title titlelabel">
					<?php echo JText::_('SMS_FIELD_LABEL'); ?>
				</th>
				<th class="title titletype">
					<?php echo JText::_('SMS_FIELD_TYPE'); ?>
				</th>
				<th class="title titletoggle">
					<?php echo JText::_('SMS_REQUIRED'); ?>
				</th>

				<th class="title titletoggle">
					<?php echo JText::_('SMS_DISPLAY_FRONTCOMP'); ?>
				</th>
				<th class="title titletoggle">
					<?php echo JText::_('SMS_DISPLAY_BACKEND'); ?>
				</th>
				<th class="title titletoggle">
					<?php echo JText::_('SMS_DISPLAY_LISTING'); ?>
				</th>
				<th class="title titletoggle">
					<?php echo JText::_('SMS_PUBLISHED'); ?>
				</th>
				<th class="title titletoggle">
					<?php echo JText::_('SMS_CORE'); ?>
				</th>
				<th class="title titleid">
					<?php echo JText::_('SMS_ID'); ?>
				</th>
			</tr>
			</thead>
			<tbody>
			<?php
			$k = 0;

			for($i = 0, $a = count($this->rows); $i < $a; $i++){
				$row =& $this->rows[$i];

				$publishedid = 'fields_published-'.$row->fields_fieldid;
				$requiredid = 'fields_required-'.$row->fields_fieldid;
				$backendid = 'fields_backend-'.$row->fields_fieldid;
				$frontcompid = 'fields_frontcomp-'.$row->fields_fieldid;
				$listingid = 'fields_listing-'.$row->fields_fieldid;
				?>
				<tr class="<?php echo "row$k"; ?>">
					<td align="center">
						<?php echo $i + 1; ?>
					</td>
						<td class="order" width="3%">
						<span class="sortable-handler">
							<i class="icon-menu"></i>
						</span>
							<input type="text" style="display:none" name="order[]" size="5" value="<?php echo $row->fields_ordering; ?>" class="width-20 text-area-order"/>
						</td>
					<td align="center">
						<?php echo JHTML::_('grid.id', $i, $row->fields_fieldid); ?>
					</td>
					<td align="center">
						<a href="<?php echo JOOMSMS::completeLink('fields&task=edit&fields_fieldid='.$row->fields_fieldid); ?>">
							<?php echo $this->escape($row->fields_namekey); ?>
						</a>
					</td>
					<td align="center">
						<?php echo $this->fieldsClass->trans($row->fields_fieldname); ?>
					</td>
					<td align="center">
						<?php echo $this->fieldtype->allValues[$row->fields_type]; ?>
					</td>
					<td align="center">
						<span id="<?php echo $requiredid ?>" class="loading"><?php echo $this->toggleClass->toggle($requiredid, (int)$row->fields_required, 'fields') ?></span>
					</td>
					<td align="center">
						<span id="<?php echo $frontcompid ?>" class="loading"><?php echo $this->toggleClass->toggle($frontcompid, (int)$row->fields_frontcomp, 'fields') ?></span>
					</td>
					<td align="center">
						<span id="<?php echo $backendid ?>" class="loading"><?php echo $this->toggleClass->toggle($backendid, (int)$row->fields_backend, 'fields') ?></span>
					</td>
					<td align="center">
						<span id="<?php echo $listingid ?>" class="loading"><?php echo $this->toggleClass->toggle($listingid, (int)$row->fields_listing, 'fields') ?></span>
					</td>
					<td align="center">
						<span id="<?php echo $publishedid ?>" class="loading"><?php echo $this->toggleClass->toggle($publishedid, (int)$row->fields_published, 'fields') ?></span>
					</td>
					<td align="center">
						<?php echo $this->toggleClass->display('activate', $row->fields_core); ?>
					</td>
					<td width="1%" align="center">
						<?php echo $row->fields_fieldid; ?>
					</td>
				</tr>
				<?php
				$k = 1 - $k;
			}
			?>
			</tbody>
			<tfoot>
			<tr>
				<td colspan="12">
					<?php echo $this->pagination->getListFooter(); ?>
					<?php echo $this->pagination->getResultsCounter(); ?>
				</td>
			</tr>
			</tfoot>
		</table>

		<input type="hidden" name="option" value="<?php echo JOOMSMS_COMPONENT; ?>"/>
		<input type="hidden" name="task" value=""/>
		<input type="hidden" name="ctrl" value="fields"/>
		<input type="hidden" name="boxchecked" value="0"/>
		<?php echo JHTML::_('form.token'); ?>
	</form>
</div>
        </div>
