<?php
/**
 * @package	JoomSMS for Joomla!
 * @version	1.0
 * @author	joomboost.com
 * @copyright	(C) 2013-2020 JoomBoost. All rights reserved.
 * @license	GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php

class GroupViewGroup extends joomsmsView{
	function display($tpl = null){
		$function = $this->getLayout();
		if(method_exists($this, $function)) $this->$function();


        // Add submenu
        JoomsmsHelper::addSubmenu();
        $this->addSidebar();

        parent::display($tpl);


    }

    protected function addSidebar()
    {
        $this->sidebar = JHtmlSidebar::render();
    }


    function listing(){
		$app = JFactory::getApplication();
		$config = JOOMSMS::config();
		$pageInfo = new stdClass();
		$pageInfo->filter = new stdClass();
		$pageInfo->filter->order = new stdClass();
		$pageInfo->limit = new stdClass();
		$pageInfo->elements = new stdClass();

		$paramBase = JOOMSMS_COMPONENT.'.'.$this->getName();

		$pageInfo->filter->order->value = $app->getUserStateFromRequest($paramBase.".filter_order", 'filter_order', 'joomsmsgroup.group_ordering', 'cmd');
		$pageInfo->filter->order->dir = $app->getUserStateFromRequest($paramBase.".filter_order_Dir", 'filter_order_Dir', 'asc', 'word');

		if($pageInfo->filter->order->dir != "asc") $pageInfo->filter->order->dir = 'desc';

		$pageInfo->search = $app->getUserStateFromRequest($paramBase.".search", 'search', '', 'string');
		$pageInfo->search = JString::strtolower(trim($pageInfo->search));

		$pageInfo->limit->value = $app->getUserStateFromRequest($paramBase.'.group_limit', 'limit', $app->getCfg('group_limit'), 'int');
		$pageInfo->limit->start = $app->getUserStateFromRequest($paramBase.'.limitstart', 'limitstart', 0, 'int');

		$listingFilters = new stdClass();

		$selectedCreator = $app->getUserStateFromRequest($paramBase."filter_creator", 'filter_creator', 0, 'int');
		$groupCreatorType = JOOMSMS::get('type.groupcreator');
		$listingFilters->creator = $groupCreatorType->display('filter_creator', $selectedCreator);

		$listingFilters->publishedStatus = '';
		$selectedPublishedStatus = $app->getUserStateFromRequest($paramBase."filter_grouppublished", 'filter_grouppublished', '1', 'int');
		$listPublishedStatus = JOOMSMS::get('type.grouppublished');
		if(!empty($listPublishedStatus->values)) $listingFilters->publishedStatus = $listPublishedStatus->display('filter_grouppublished', $selectedPublishedStatus);


		$db = JFactory::getDBO();

		$searchMap = array('joomsmsgroup.group_name', 'joomsmsgroup.group_description', 'joomsmsgroup.group_id');
		$filters = array();

		if(!$app->isAdmin()){
			$my = JFactory::getUser();

				jimport('joomla.access.access');
				$groups = JAccess::getGroupsByUser($my->id, false);
				$condGroup = '';
				foreach($groups as $group){
					$condGroup .= ' OR group_access_manage LIKE (\'%,'.$group.',%\')';
					$condGroup .= ' OR group_user_id = '.intval($my->id);
			}
			$filters[] = '(group_access_manage = \'all\' '.$condGroup.')';
		}


		if(!empty($pageInfo->search)){
			$searchVal = '\'%'.joomsms_getEscaped($pageInfo->search, true).'%\'';
			$filters[] = implode(" LIKE $searchVal OR ", $searchMap)." LIKE $searchVal";
		}

		if(!empty($selectedCreator)) $filters[] = 'joomsmsgroup.group_user_id = '.intval($selectedCreator);
		if(!empty($selectedPublishedStatus)) $filters[] = 'joomsmsgroup.group_published = '.$db->quote($selectedPublishedStatus);

		$query = 'SELECT joomsmsgroup.*, joomusers.name AS creatorname, joomusers.username, joomusers.email AS email';
		$query .= ' FROM '.JOOMSMS::table('group').' AS joomsmsgroup';
		$query .= ' LEFT JOIN #__users AS joomusers on joomsmsgroup.group_user_id = joomusers.id';
		if(!empty($filters)) $query .= ' WHERE ('.implode(') AND (', $filters).')';
		if(!empty($pageInfo->filter->order->value)){
			$query .= ' ORDER BY '.$pageInfo->filter->order->value.' '.$pageInfo->filter->order->dir;
		}

		$db->setQuery($query, $pageInfo->limit->start, $pageInfo->limit->value);
		$rows = $db->loadObjectList();

		$queryCount = 'SELECT COUNT(joomsmsgroup.group_id) FROM  '.JOOMSMS::table('group').' AS joomsmsgroup';
		if(!empty($pageInfo->search)) $queryCount .= ' LEFT JOIN '.JOOMSMS::table('users', false).' AS joomusers on joomsmsgroup.group_user_id = joomusers.id';

		if(!empty($filters)) $queryCount .= ' WHERE ('.implode(') AND (', $filters).')';

		$db->setQuery($queryCount);
		$pageInfo->elements->total = $db->loadResult();

		$groupsids = array();
		foreach($rows as $oneRow){
			$groupsids[] = intval($oneRow->group_id);
		}

		JArrayHelper::toInteger($groupsids);

		$subscriptionresults = array();
		if(!empty($groupsids)){
			$querySubscription = 'SELECT count(groupuser_group_id) AS total, groupuser_group_id, groupuser_status FROM '.JOOMSMS::table('groupuser').' WHERE groupuser_group_id IN ('.implode(',', $groupsids).') GROUP BY groupuser_group_id, groupuser_status';
			$db->setQuery($querySubscription);
			$countresults = $db->loadObjectList();
			foreach($countresults as $oneResult){
				$subscriptionresults[$oneResult->groupuser_group_id][intval($oneResult->groupuser_status)] = $oneResult->total;
			}
		}

		foreach($rows as $i => $oneRow){
			$rows[$i]->nbsub = intval(@$subscriptionresults[$oneRow->group_id][1]);
		}

		if(!empty($pageInfo->search)){
			$rows = JOOMSMS::search($pageInfo->search, $rows);
		}

		$pageInfo->elements->page = count($rows);

		jimport('joomla.html.pagination');
		$pagination = new JPagination($pageInfo->elements->total, $pageInfo->limit->start, $pageInfo->limit->value);

		if($app->isAdmin()){
            JToolbarHelper::title(JText::_('SMS_GROUPS'), 'group');

            JToolbarHelper::addNew('add');
            JToolbarHelper::editList('edit');
            if(JOOMSMS::isAllowed($config->get('acl_groups_delete', 'all'))) JToolbarHelper::deleteList();

            JToolbarHelper::custom('archive','archive','archive',JText::_('SMS_ARCHIVE').' / '.JText::_('SMS_UNARCHIVE'),true);

		}
		$order = new stdClass();
		$order->ordering = false;
		$order->orderUp = 'orderup';
		$order->orderDown = 'orderdown';
		$order->reverse = false;
		if($pageInfo->filter->order->value == 'joomsmsgroup.group_ordering'){
			$order->ordering = true;
			if($pageInfo->filter->order->dir == 'desc'){
				$order->orderUp = 'orderdown';
				$order->orderDown = 'orderup';
				$order->reverse = true;
			}
		}

		$this->assignRef('filters', $listingFilters);
		$this->assignRef('order', $order);
		$toggleClass = JOOMSMS::get('helper.toggle');
		$this->assignRef('toggleClass', $toggleClass);
		$this->assignRef('rows', $rows);
		$this->assignRef('pageInfo', $pageInfo);
		$this->assignRef('pagination', $pagination);
		$this->assignRef('app', $app);
		$this->assignRef('config', $config);
	}

	function form()
    {
        $app = JFactory::getApplication();
        JHTML::_('behavior.modal', 'a.modal');

        $group_id = JOOMSMS::getCID('group_id');

        $groupClass = JOOMSMS::get('class.group');
        if (!empty($group_id)) {
            $group = $groupClass->get($group_id);
            if (!empty($group->group_user_id)) {
                $user = JFactory::getUser($group->group_user_id);
                $group->group_creatorname = $user->name;
            }
        } else {
            $group = new stdClass();
            $group->group_published = 0;
            $group->group_description = '';
            $group->group_published = 1;
            $group->group_access_manage = 'none';
            $user = JFactory::getUser();
            $group->group_creatorname = $user->name;
            $colors = array('#3366ff', '#7240A4', '#7A157D', '#157D69', '#ECE649');
            $group->group_color = $colors[rand(0, count($colors) - 1)];
        }

        $acltype = JOOMSMS::get('type.acl');

        $editor = JOOMSMS::get('helper.editor');
        $editor->name = 'editor_description';
        $editor->content = $group->group_description;
        $editor->setDescription();

        $script = 'Joomla.submitbutton = function(pressbutton) {
						if (pressbutton == \'cancel\') {
							Joomla.submitform(pressbutton,document.adminForm);
							return;
						}';


        $script .= 'if(window.document.getElementById("name").value.length < 2){alert(\'' . JText::_('ENTER_TITLE', true) . '\'); return false;}';
        $script .= $editor->jsCode();

        $script .= 'Joomla.submitform(pressbutton,document.adminForm);}; ';

        $script .= 'function affectUser(idcreator,name,email){
			window.document.getElementById("creatorname").innerHTML = name;
			window.document.getElementById("groupcreator").value = idcreator;
		}';


        $doc = JFactory::getDocument();
        $doc->addScriptDeclaration($script);

        $colorBox = JOOMSMS::get('type.color');

        if ($app->isClient('administrator')) {

            JToolbarHelper::title(JText::_('SMS_GROUP','fas fa-list isChild'));
            JToolbarHelper::apply('apply');
            JToolbarHelper::save('save');
            JToolbarHelper::cancel();
        }
            $this->assignRef('colorBox', $colorBox);
            $this->assignRef('group', $group);
            $this->assignRef('editor', $editor);
            $this->assignRef('acltype', $acltype);
            $this->assignRef('app', $app);

    }
	public function choose(){
		$app = JFactory::getApplication();
		$groupClass = JOOMSMS::get('class.group');
		$rows = $app->isAdmin() ? $groupClass->getGroups() : $groupClass->getFrontendGroups();

		$selectedGroups = JRequest::getVar('values', '', '', 'string');

		if(strtolower($selectedGroups) == 'all'){
			foreach($rows as $id => $oneRow){
				$rows[$id]->selected = true;
			}
		}elseif(!empty($selectedGroups)){
			$selectedGroups = explode(',', $selectedGroups);
			foreach($rows as $id => $oneRow){
				if(in_array($oneRow->group_id, $selectedGroups)){
					$rows[$id]->selected = true;
				}
			}
		}

		$fieldName = JRequest::getString('task');
		$controlName = JRequest::getString('control', 'params');
		$nbDisplay = JRequest::getInt('nb_display', -1);

		if($nbDisplay != -1) $this->assignRef('nbDisplay', $nbDisplay);

		$this->assignRef('rows', $rows);
		$this->assignRef('selectedGroups', $selectedGroups);
		$this->assignRef('fieldName', $fieldName);
		$this->assignRef('controlName', $controlName);
	}
}