<?php
/**
 * @package	JoomSMS for Joomla!
 * @version	1.0
 * @author	joomboost.com
 * @copyright	(C) 2013-2020 JoomBoost. All rights reserved.
 * @license	GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?>

<?php if (!empty($this->sidebar)): ?>
<div id="j-sidebar-container" class="span2">
    <?php echo $this->sidebar; ?>
</div>
<div id="j-main-container" class="span10">
    <?php else : ?>
    <div id="j-main-container">
        <?php endif; ?>
        <div class="row-fluid span12">

<div id="joomsms_content">
	<div id="iframedoc"></div>
	<form action="index.php?option=<?php echo JOOMSMS_COMPONENT ?>&amp;ctrl=senderprofile" method="post" name="adminForm" id="adminForm">
		<table class="table table-striped joomsms_table_options">
			<tr>
				<td>
					<?php JOOMSMS::listingSearch($this->escape($this->pageInfo->search)); ?>
				</td>
			</tr>
		</table>

		<table class="joomsms_table table table-striped">
			<thead>
			<tr>
				<th class="title titlenum">
					<?php echo JText::_('SMS_NUM'); ?>
				</th>
				<th class="title titlebox">
					<input type="checkbox" name="toggle" value="" onclick="joomsms_js.checkAll(this);"/>
				</th>
				<th class="title titlename">
					<?php echo JHTML::_('grid.sort', JText::_('SMS_SENDER_PROFILE_NAME'), 'a.senderprofile_name', $this->pageInfo->filter->order->dir, $this->pageInfo->filter->order->value); ?>
				</th>
				<th class="title titlegateway">
					<?php echo JHTML::_('grid.sort', JText::_('SMS_GATEWAY'), 'a.senderprofile_gateway', $this->pageInfo->filter->order->dir, $this->pageInfo->filter->order->value); ?>
				</th>
				<th class="title titlesender">
					<?php echo JHTML::_('grid.sort', JText::_('SMS_CREATOR'), 'b.name', $this->pageInfo->filter->order->dir, $this->pageInfo->filter->order->value); ?>
				</th>
				<th class="title titletoggle">
					<?php echo JHTML::_('grid.sort', JText::_('SMS_DEFAULT'), 'a.senderprofile_default', $this->pageInfo->filter->order->dir, $this->pageInfo->filter->order->value); ?>
				</th>
				<th class="title titleid">
					<?php echo JHTML::_('grid.sort', JText::_('SMS_ID'), 'a.senderprofile_id', $this->pageInfo->filter->order->dir, $this->pageInfo->filter->order->value); ?>
				</th>
			</tr>
			</thead>
			<tfoot>
			<tr>
				<td colspan="7">
					<?php echo $this->pagination->getListFooter(); ?>
					<?php echo $this->pagination->getResultsCounter(); ?>
				</td>
			</tr>
			</tfoot>
			<tbody>
			<?php
			$k = 0;

			for($i = 0, $a = count($this->rows); $i < $a; $i++){
				$row =& $this->rows[$i];
				$visibleid = 'senderprofile_id-'.$row->senderprofile_id;
				?>
				<tr class="<?php echo "row$k"; ?>">
					<td align="center">
						<?php echo $this->pagination->getRowOffset($i); ?>
					</td>
					<td align="center">
						<?php echo JHTML::_('grid.id', $i, $row->senderprofile_id); ?>
					</td>
					<td align="center">
						<?php echo '<a href="'.JOOMSMS::completeLink('senderprofile&task=edit&cid[]='.$row->senderprofile_id).'">'.JOOMSMS::dispSearch($row->senderprofile_name, $this->pageInfo->search).'</a>'; ?>
					</td>
					<td align="center">
						<?php echo $row->senderprofile_gateway; ?>
					</td>
					<td align="center">
						<?php
						if(!empty($row->name)){
							$text = '<b>'.JText::_('SMS_NAME').' : </b>'.$row->name;
							$text .= '<br /><b>'.JText::_('SMS_USERNAME').' : </b>'.$row->username;
							$text .= '<br /><b>'.JText::_('SMS_EMAIL').' : </b>'.$row->email;
							$text .= '<br /><b>'.JText::_('SMS_ID').' : </b>'.$row->senderprofile_userid;
							echo JOOMSMS::tooltip($text, $row->name, '', $row->name, 'index.php?option=com_users&task=edit&cid[]='.$row->senderprofile_userid);
						}
						?>
					</td>
					<td align="center" id="icon">
						<span id="<?php echo $visibleid ?>" class="loading"><?php echo $this->toggleHelper->toggle($visibleid, $row->senderprofile_default, 'senderprofile') ?></span>
					</td>
					<td width="1%" align="center">
						<?php echo $row->senderprofile_id; ?>
					</td>
				</tr>
				<?php
				$k = 1 - $k;
			}
			?>
			</tbody>
		</table>
		<script type="text/javascript">
			function switchDefault(idField){
				var table = document.getElementsByClassName('joomsms_table table table-striped')[0];//The table of the gateways
				var tr = table.getElementsByTagName('tbody')[0].getElementsByTagName('tr');//The gateways
                for(var i = 0; i < tr.length; i++){ //Change all the icon to cancel icon
                    var icon = tr[i].getElementById('icon'); //The td that contain the icon
                    var a = icon.getElementsByTagName('a')[0]; //The icon
					var span = icon.getElementsByTagName('span')[0]; //the span get the id of the gateway
					var id = span.id.replace('senderprofile_id-', ''); //The treatment to get the id of the gateway
					a.className = 'smsicon-cancel'; //Change the icon to cancel icon
				}
				joomTogglePicture('senderprofile_id-' + idField, '1', 'senderprofile'); //we set the new default gateway
			}
		</script>

		<input type="hidden" name="option" value="<?php echo JOOMSMS_COMPONENT; ?>"/>
		<input type="hidden" name="task" value=""/>
		<input type="hidden" name="ctrl" value="<?php echo JRequest::getCmd('ctrl'); ?>"/>
		<input type="hidden" name="boxchecked" value="0"/>
		<input type="hidden" name="filter_order" value="<?php echo $this->pageInfo->filter->order->value; ?>"/>
		<input type="hidden" name="filter_order_Dir" value="<?php echo $this->pageInfo->filter->order->dir; ?>"/>
		<?php echo JHTML::_('form.token'); ?>
	</form>
</div>
        </div>