<?php
/**
 * @package	JoomSMS for Joomla!
 * @version	1.0
 * @author	joomboost.com
 * @copyright	(C) 2013-2020 JoomBoost. All rights reserved.
 * @license	GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php

if(version_compare(PHP_VERSION, '5.0.0', '<')){
	echo '<p style="color:red">This version of JoomSMS does not support PHP4, it is time to upgrade your server to PHP5!</p>';
	exit;
}

if(!function_exists('com_install')){
	function com_install(){
		return installJoomSMS();
	}
}

if(!function_exists('com_uninstall')){
	function com_uninstall(){
		return uninstallJoomSMS();
	}
}

class com_joomsmsInstallerScript{
	function install($parent){
		installJoomSMS();
	}

	function update($parent){
		installJoomSMS();
	}

	function preflight($type, $parent){
		return true;
	}

	function postflight($type, $parent){
		return true;
	}
}



function installJoomSMS(){
	include_once(rtrim(JPATH_ADMINISTRATOR, DIRECTORY_SEPARATOR).DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_joomsms'.DIRECTORY_SEPARATOR.'helpers'.DIRECTORY_SEPARATOR.'helper.php');

	JOOMSMS::increasePerf();

	$installClass = new joomsmsInstall();
	$installClass->addPref();
	$installClass->updatePref();
	$installClass->secureRequests();
}


class joomsmsInstall{

	var $level = 'connect';
	var $version = '1.0';
	var $fromVersion = '';
	var $fromLevel = '';
	var $db;
	var $update = false;

	function __construct(){
		$this->db = JFactory::getDBO();
	}


	function addPref(){
		$allPref = array();

		$this->level = ucfirst($this->level);

		$allPref['level'] = $this->level;
		$allPref['version'] = $this->version;

		$allPref['cron_frequency'] = 900;
		$allPref['cron_plugins_next'] = time() + 86400;
		$allPref['cron_savepath'] = 'media/com_joomsms/logs/report'.rand(0, 999999999).'.log';
		$allPref['version'] = $this->version;
		$allPref['cron_savepath'] = 'media/com_joomsms/logs/report'.rand(0, 999999999).'.log';
		$allPref['menu_position'] = 'above';
		$allPref['allowedfiles'] = 'zip,doc,docx,pdf,xls,txt,gzip,rar,jpg,gif,xlsx,pps,csv,bmp,ico,odg,odp,ods,odt,png,ppt,swf,xcf,mp3,wma';
		$allPref['uploadfolder'] = 'media/com_joomsms/upload';
		$allPref['default_integration'] = 'joomsms';
		$allPref['joomsms_field'] = 'user_phone_number';
		$allPref['queue_nbmsg'] = '200';
		$allPref['parallel_threads'] = '10';
		$allPref['export_excelsecurity'] = 1;

		$app = JFactory::getApplication();
		$currentTemplate = $app->getTemplate();
		if(in_array($currentTemplate, array('rt_missioncontrol', 'aplite', 'adminpraise3'))){
			$allPref['menu_position'] = 'above';
		}
		$query = "INSERT IGNORE INTO `#__joomsms_config` (`namekey`,`value`) VALUES ";
		foreach($allPref as $namekey => $value){
			$query .= '('.$this->db->Quote($namekey).','.$this->db->Quote($value).'),';
		}
		$query = rtrim($query, ',');
		$this->db->setQuery($query);
		$this->db->query();
	}

	function updatePref(){
		$this->db->setQuery("SELECT `namekey`, `value` FROM `#__joomsms_config` WHERE `namekey` IN ('version','level') LIMIT 2");
		try{
			$results = $this->db->loadObjectList('namekey');
		}catch(Exception $e){
			$results = null;
		}

		if($results === null){
			JOOMSMS::display(isset($e) ? $e->getMessage() : substr(strip_tags($this->db->getErrorMsg()), 0, 200).'...', 'error');
			return false;
		}

		if($results['version']->value == $this->version AND $results['level']->value == $this->level) return true;

		$this->update = true;
		$this->fromLevel = $results['level']->value;
		$this->fromVersion = $results['version']->value;

		$query = "REPLACE INTO `#__joomsms_config` (`namekey`,`value`) VALUES ('level',".$this->db->Quote($this->level)."),('version',".$this->db->Quote($this->version)."),('installcomplete','0')";
		$this->db->setQuery($query);
		$this->db->query();

		return true;
	}

	function updatequery($query){
		try{
			$this->db->setQuery($query);
			$res = $this->db->query();
		}catch(Exception $e){
			$res = null;
		}

		if($res === null) JOOMSMS::display(isset($e) ? print_r($e, true) : substr(strip_tags($this->db->getErrorMsg()), 0, 200).'...', 'error');
	}

	function secureRequests(){
		$config = JOOMSMS::config();
		$pass = $config->get('pass');
		if(!empty($pass)) return;
		jimport('joomla.user.helper');
		$pass = JUserHelper::genRandomPassword(30);

		$newConfig = new stdClass();
		$newConfig->pass = $pass;
		$config->save($newConfig);
	}
}

