<?php
/**
 * @package	JoomSMS for Joomla!
 * @version	1.0
 * @author	joomboost.com
 * @copyright	(C) 2013-2020 JoomBoost. All rights reserved.
 * @license	GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php

class ActivateController extends joomsmsController{

	var $errors = array();

	function __construct($config = array()){
		parent::__construct($config);
		$this->registerDefaultTask('activate');
	}

	function activate(){
		JRequest::setVar('layout', 'activate');
		return parent::display();
	}

	function saveActivation(){

		$phoneNumber = JRequest::getVar("phoneNumber", array(), '', 'array');
		$phoneNumber = trim(strip_tags($phoneNumber['phone_country'].$phoneNumber['phone_num']));

		$activationCode = JRequest::getString("activationCode", '');
		$moduleId = JRequest::getInt("moduleId", '');
		$db = JFactory::getDBO();
		$app = JFactory::getApplication();

		if(empty($moduleId)) return;
		$db->setQuery('SELECT params FROM #__modules WHERE id = '.intval($moduleId).' AND `module` LIKE \'%joomsms%\' LIMIT 1');
		$dbParams = $db->loadResult();

		$moduleParameter = new joomsmsParameter($dbParams);
		$redirectLink = $moduleParameter->get('redirectlink');

		$phoneHelper = JOOMSMS::get('helper.phone');
		$result = $phoneHelper->verifyActivation($phoneNumber, $activationCode, 'activation_optin');


		if($result){

			$validPhone = $phoneHelper->getValidNum($phoneNumber);
			$userClass = JOOMSMS::get('class.user');
			$user = $userClass->getByPhone($validPhone);

			$query = 'UPDATE #__joomsms_groupuser SET groupuser_status = 1 WHERE groupuser_status = 2 && groupuser_user_id = '.intval($user->user_id);
			$db->setQuery($query);
			$db->query();

			$phoneClass = JOOMSMS::get('class.phone');
			$phoneClass->unblock(array($validPhone));

			JOOMSMS::enqueueMessage(JText::_('SMS_SUCCESSFULLY_ACTIVATED'), 'success');
			if($redirectLink) $app->redirect($redirectLink);
			$app->redirect(JOOMSMS_LIVE);
			exit;
		}
		JOOMSMS::enqueueMessage($phoneHelper->error, 'error');
		JRequest::setVar('layout', 'activate');
		return parent::display();
	}
}
