<?php
/**
 * @package	JoomSMS for Joomla!
 * @version	1.0
 * @author	joomboost.com
 * @copyright	(C) 2013-2020 JoomBoost. All rights reserved.
 * @license	GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php

class DeliveryReportController extends joomsmsController{

	function __construct($config = array()){
		parent::__construct($config);
		$this->registerDefaultTask('deliveryReport');
	}

	function deliveryReport(){
		$config = JOOMSMS::config();

		$gatewayName = JRequest::getCmd("gateway", JRequest::getCmd('g'));
		if(empty($gatewayName)) die('No gateway specified');

		$pass = JRequest::getCmd("pass", JRequest::getCmd("p", ''));
		if(empty($pass) || $pass != $config->get('pass')) die('Pass not valid');


		$gatewayClass = JOOMSMS::get('class.senderprofile');
		$gateway = $gatewayClass->getGateway($gatewayName);
		if(empty($gateway)) die("Can't load gateway");

		$apiAnswer = $gateway->deliveryReport();

		$statsClass = JOOMSMS::get('class.stats');
		$statsClass->addDeliveryInformations($apiAnswer);

		$gateway->closeRequest();

		exit;
	}
}
