<?php
/**
 * @package	JoomSMS for Joomla!
 * @version	1.0
 * @author	joomboost.com
 * @copyright	(C) 2013-2020 JoomBoost. All rights reserved.
 * @license	GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php
$my = JFactory::getUser();
if(empty($my->id)){
	$usercomp = 'com_users';
	$uri = JFactory::getURI();
	$url = 'index.php?option='.$usercomp.'&view=login&return='.base64_encode($uri->toString());
	$app = JFactory::getApplication();
	$app->redirect($url, JText::_('SMS_NOTALLOWED'));
	return false;
}

$config = JOOMSMS::config();
if(!$config->get('allowFrontEndManagement') || !JOOMSMS::isAllowed($config->get('acl_receivers_manage', 'all'))) die('You are not allowed to access this page');


include(JOOMSMS_BACK.'controllers'.DS.'user.php');
$frontHelper = JOOMSMS::get('helper.joomsmsfront');

class FrontUserController extends UserController{
	function __construct($config = array()){
		parent::__construct($config);

		$groupid = checkGroupId();
		JRequest::setVar('filter_group', $groupid);
		JRequest::setVar('group_id', $groupid);

		JPluginHelper::importPlugin('joomsms');
		$dispatcher = JDispatcher::getInstance();
		$resultArray = $dispatcher->trigger('joomsmsCheckCustomAccessGroup');
		$result = reset($resultArray);
		if(!empty($result)) return true;

		$app = JFactory::getApplication();
		if(in_array(JRequest::getCmd('task'), array('edit', 'add')) && !joomsmsCheckEditUser()){
			JOOMSMS::enqueueMessage('This user does not belong to your group', 'error');
			$app->redirect('index.php?option=com_joomsms');
			return false;
		}
	}

	function conversation(){
		die('Conversation is not available on the front end');
	}
}
