<?php
/**
 * @package	JoomSMS for Joomla!
 * @version	1.0
 * @author	joomboost.com
 * @copyright	(C) 2013-2020 JoomBoost. All rights reserved.
 * @license	GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php

class UnsubscribeController extends joomsmsController{

	function __construct($config = array()){
		parent::__construct($config);
		$this->registerDefaultTask('unsubscribe');
	}

	function unsubscribe(){
		JRequest::setVar('layout', 'unsubscribe');
		return parent::display();
	}

	/* auto unsubscribe by passing number in get */
	function auto(){

	    $this->save();

    }



	function saveunsub(){

		JRequest::checkToken() or die('Invalid Token');

		$this->save();

	}

	function save(){

        $db = JFactory::getDBO();

        $phoneHelper = JOOMSMS::get('helper.phone');
        $phoneClass = JOOMSMS::get('class.phone');

        $number = JRequest::getVar("number", '');

        $number = is_array($number) ? implode(',', JRequest::getVar("number", '') ): $number;

        $validPhoneNumber = $phoneHelper->getValidNum($number);

        if(!$validPhoneNumber){
            JOOMSMS::enqueueMessage($phoneHelper->error, 'warning');
            JRequest::setVar('layout', 'unsubscribe');
            return parent::display();
        }

        $query = 'SELECT phone_number FROM '.JOOMSMS::table("phone").' WHERE phone_number = '.$db->Quote($validPhoneNumber);
        $db->setQuery($query);
        $status = $db->loadResult();

        if(empty($status)){

            $phoneClass->manageStatus($validPhoneNumber, 0);
            JOOMSMS::enqueueMessage(JText::_('SMS_SUCCESSFULLY_UNSUBSCRIBED'), 'success');
            JRequest::setVar('layout', 'saveunsub');
            return parent::display();
        }

        JOOMSMS::enqueueMessage(JText::_('SMS_ALREADY_UNSUBSCRIBE'), 'success');
        JRequest::setVar('layout', 'saveunsub');
        return parent::display();
    }

}
