<?php
/**
 * @package      JoomSMS
 * @author       JoomBoost
 * @copyright    Copyright (C) 2013-2020 JoomBoost. All rights reserved.
 * @license      http://www.gnu.org/licenses/gpl.html GNU/GPL, see LICENSE.txt
 */

defined('_JEXEC') or die();


class pkg_joomsmsInstallerScript
{
    /**
     * Called before any type of action
     *
     * @param     string              $route      Which action is happening (install|uninstall|discover_install)
     * @param     jadapterinstance    $adapter    The object responsible for running this script
     *
     * @return    boolean                         True on success
     */
    public function preflight($route, JAdapterInstance $adapter)
    {
        // Joomla version check
        if (!version_compare(JVERSION, '3.6', 'ge')) {
            $adapter->get('parent')->abort('Unsupported version! JoomSMS requires Joomla 3.6 or newer.');
            return false;
        }
        return true;
    }


    /**
     * Called after any type of action
     *
     * @param     string              $route      Which action is happening (install|uninstall|discover_install)
     * @param     jadapterinstance    $adapter    The object responsible for running this script
     *
     * @return    boolean                         True on success
     */
    public function postflight($route, JAdapterInstance $adapter)
    {

        if($route == 'install' || $route == 'discover_install'){
            //enable plugin system

                {
                    $db = JFactory::getDbo();
                    $query = $db->getQuery(true);

                    $fields = array(
                        $db->quoteName('enabled') . ' = 1'
                    );

                    $conditions = array(
                        $db->quoteName('element') . ' = ' . $db->quote('joomsms'),
                        $db->quoteName('type') . ' = ' . $db->quote('plugin'),
                        $db->quoteName('folder') . ' = ' . $db->quote('system'),
                    );

                    $query->update($db->quoteName('#__extensions'))->set($fields)->where($conditions);

                    $db->setQuery($query);
                    $db->execute();
                }

        }

        return true;
    }
}
