<?php
/**
 * @package	JoomSMS for Joomla!
 * @version	1.0
 * @author	JoomBoost
 * @copyright	(C) 2013-2020 JoomBoost. All rights reserved.
 * @license	GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

JLoader::register('JOOMSMScountryType',JPATH_ADMINISTRATOR.'/components/com_joomsms/types/country.php');

class plgJoomsmsJoomlauser extends JPlugin{
    public $sendervalues = array();
    public $lastName = '';
    public $firstName = '';
    public $email = '';
    public $phoneNumber = '';

    function __construct(&$subject, $config){

        parent::__construct($subject, $config);

        if(!isset($this->params)){
            $plugin = JPluginHelper::getPlugin('joomsms', 'joomlauser');
            $this->params = new JRegistry($plugin->params);
        }

        // set body
        $this->app = JFactory::getApplication();


    }

    function onJOOMSMSGetTags(&$tags){
        $tags['communityTags']['joomlauser'] = new stdClass();
        $tags['communityTags']['joomlauser']->name = JText::sprintf('SMS_X_USER_INFO', 'Joomla');

        $tableFields = joomsms_getColumns('#__users');
        $tags['communityTags']['joomlauser']->content = '<table class="joomsms_table"><tbody>';
        $k = 0;
        foreach($tableFields as $oneField => $fieldType){
            $tags['communityTags']['joomlauser']->content .= '<tr style="cursor:pointer" onclick="insertTag(\'{joomlauser:'.$oneField.'}\')" class="row'.$k.'"><td>'.$oneField.'</td></tr>';
            $k = 1 - $k;
        }
        $tags['communityTags']['joomlauser']->content .= '</tbody></table>';
    }

    function onJOOMSMSReplaceUserTags(&$message, &$juser, $send = true){

        $db = JFactory::getDBO();

        $query = 'SELECT queue_paramqueue FROM '.JOOMSMS::table('queue').' WHERE queue_message_id = '.intval($message->message_id);
        $db->setQuery($query);
        $paramQueue = $db->loadResult();
        if(!empty($paramQueue)) $paramQueue = unserialize($paramQueue);

        $match = '#(?:{|%7B)joomlauser:(.*)(?:}|%7D)#Ui';
        $variables = array('message_body');
        if(empty($message->message_body)) return;
        if(!preg_match_all($match, $message->message_body, $results)) return;
        $tags = array();
        foreach($results[0] as $i => $oneTag){
            if(isset($tags[$oneTag])) continue;
            $arguments = explode('|', strip_tags($results[1][$i]));
            $field = $arguments[0];
            unset($arguments[0]);
            $mytag = new stdClass();
            $mytag->default = '';
            if(!empty($arguments)){
                foreach($arguments as $onearg){
                    $args = explode(':', $onearg);
                    if(isset($args[1])){
                        $mytag->$args[0] = $args[1];
                    }else{
                        $mytag->$args[0] = 1;
                    }
                }
            }
            if($field == 'password' && !empty($paramQueue->password)){
                $tags[$oneTag] = base64_decode($paramQueue->password);
            }else $tags[$oneTag] = (isset($juser->joomla->$field) && strlen($juser->joomla->$field) > 0) ? $juser->joomla->$field : $mytag->default;
        }
        $message->message_body = str_replace(array_keys($tags), $tags, $message->message_body);
    }


    public function fillViewComponent(&$view_compo){
        $firstOption = 'com_user';
        $secondOption = 'com_users';
        $firstView = 'register';
        $secondView = 'registration';
        $view_compo[$firstOption] = $firstView;
        $view_compo[$secondOption] = $secondView;

    }

    public function getNeededIntegration($integration){

        $config = JOOMSMS::config();
        if($integration == 'joomlasub'){
            return $config->get('require_confirmation_joomla_subscription');
        }
    }

    public function displayConfirmationError($informations){

        $task = $informations['task'];
        $option = $informations['option'];
        if(($task == 'register_save' && $option == 'com_user') || ($task == 'registration.register' && $option == 'com_users')){
            if($this->getNeededIntegration('joomlasub')){
                echo '<script>alert("Phonenumber confirmation did not process");history.back();</script>';
                exit;
            }
        }
    }

    public function displayConfirmationArea($infoUrl){
        $option = $infoUrl['option'];
        $view = $infoUrl['view'];

        if(!$this->getNeededIntegration('joomlasub')) return;

        // registration using SMS
        if($option == 'com_users' && $view == 'registration'){
            $newField = $this->displayPhoneField('joomlasub');
            $this->_replaceConfirmButtonJoomlaSub($newField);
        }

        // password reset using SMS
        if($option == 'com_users' && $view == 'reset' && $this->params->get('enable_reset_pass_with_sms',0)){

            $newField =  JLayoutHelper::render('phonefieldreset',[],__DIR__.'/layouts');
            $this->_replaceConfirmButtonJoomlaSub($newField,'user-registration','');

        }

    }

    private function _replaceConfirmButtonJoomlaSub($newField,$id="member-registration",$extraReplace = ''){

        $body = preg_replace(
            "#(<form.*id=\"".$id."\".*>.*)".$extraReplace."<button type=\"submit\".*>.*<\/button>(.*<\/form>)#sU", '$1'.$newField.'$2',
            $this->app->getBody()
        );
        $this->app->setBody($body);
    }


    public function displayPhoneField($integration, $extraInformations = null){

        if($integration != 'joomlasub')
            return '';

        return JLayoutHelper::render('phonefield',[ 'phoneFieldToDisplay' => $this->getPhoneField()],__DIR__.'/layouts');

    }


    public function getPhoneField(){

        if(preg_match("#<input type=\"tel|text\".*id=\"jform_profile_phone\".*>#", $this->app->getBody()))
            return '';

        $countryType = new JOOMSMScountryType();
        $countryType->phonewidth = 20;
        return $countryType->displayPhone(JOOMSMS::config()->get('country'), 'phonenumber_verification');

    }


}
