<?php
/**
 * @package	JoomSMS for Joomla!
 * @version	1.0
 * @author	JoomBoost
 * @copyright	(C) 2013-2020 JoomBoost. All rights reserved.
 * @license	GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

extract($displayData);

?>
<style>

    #user-registration > fieldset > div{
        display: none
    }

    #user-registration input{
        height: auto !important;
    }
    #user-registration .joomsms_buttonCountryCode{
        min-height: 26px;
        margin-bottom: -2px;
    }
</style>

<div id="joomsmsPhoneFieldGroup" style="display: none">
    <p class="alert alert-info" ><?php echo  JText::_('COM_JOOMSMS_PASSWORD_RESET_DESC') ?></p>
    <div class="control-group">
        <div class="control-label">
            <label
                    id="jform_profile_phone-lbl"
                    for="jform_profile_phone"
                    class="hasPopover"
                    title=""
                    data-original-title="<?php echo JText::_('SMS_FIELD_PHONE') ?>">
                <?php echo JText::_('SMS_FIELD_PHONE') ?>
            </label>
        </div>
        <div class="controls">
            <input type="tel" name="phone" id="jform_profile_phone" value="" size="30" required>
        </div>
    </div>
</div>


<div id="joomsms_button_send">

    <button class="btn btn-primary" type="button" onclick="resetPass();">
        <?php echo JText::_('COM_JOOMSMS_RESET_PASSWORD') ?>
    </button>
</div>

<script>

    // remove email field, cuz not needed
    jQuery('#user-registration > fieldset').empty();
    jQuery('#joomsmsPhoneFieldGroup').appendTo('#user-registration > fieldset').show();

    resetPass = function(){


        form = document.getElementById("user-registration");
        if(!document.formvalidator.isValid(form)) return;

        phonenumber = document.getElementById("jform_profile_phone").value;


        jQuery.ajax({
            url: Joomla.getOptions('system.paths').root+"/index.php?option=com_joomsms&task=verification.resetPassword&"+Joomla.getOptions('csrf.token')+"=1",
            type: "post",
            data: { phone : phonenumber },
            success: function(response) {

                const message = "<p>"+response.message+"</p>"

                if(response.error == 'true')
                    jQuery(message).insertAfter('#joomsms_button_send').addClass('alert alert-danger')
                else {
                    jQuery(message).insertAfter('#joomsms_button_send').addClass('alert alert-success')
                }

                jQuery('#joomsms_button_send').remove();
            }
        });

    };

</script>
