<?php
/**
 * @package	JoomSMS for Joomla!
 * @version	1.0
 * @author	JoomBoost
 * @copyright	(C) 2013-2020 JoomBoost. All rights reserved.
 * @license	GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php

class plgJoomsmsJoomSMS extends JPlugin{
	function __construct(&$subject, $config){
		parent::__construct($subject, $config);
	}



	function onJOOMSMSGetMessageType(&$types, $integration){
		if($integration == 'joomsms'){
			$newType = new stdClass();
			$newType->name = JText::_('SMS_AUTO_SUBSCRIPTION');
			$types['joomsmssubscription'] = $newType;
		}
	}

	function onJOOMSMSdisplayParamsAutoMessage_joomsmssubscription(){
		$db = JFactory::getDBO();

		$query = 'SELECT group_name, group_id FROM #__joomsms_group ORDER BY group_ordering ASC';
		$db->setQuery($query);
		$groups = $db->loadObjectList();

		$timevalue = array();
		$timevalue[] = JHTML::_('select.option', 'hours', JText::_('SMS_HOURS'));
		$timevalue[] = JHTML::_('select.option', 'days', JText::_('SMS_DAYS'));
		$timevalue[] = JHTML::_('select.option', 'weeks', JText::_('SMS_WEEKS'));
		$timevalue[] = JHTML::_('select.option', 'months', JText::_('SMS_MONTHS'));
		$delay = JHTML::_('select.genericlist', $timevalue, "data[message][message_receiver][auto][joomsmssubscription][delay][timevalue]", 'size="1" style="width:auto"', 'value', 'text', '0');

		$timeNumber = '<input type="text" name="data[message][message_receiver][auto][joomsmssubscription][delay][duration]" class="inputbox" style="width:30px" value="0">';
		echo JText::sprintf('SMS_SEND_GROUP_AUTO', $timeNumber.' '.$delay).'<br />';
		foreach($groups as $oneGroup){ ?>
			<label><input type="checkbox" name="data[message][message_receiver][auto][joomsmssubscription][joomsmsgroups][<?php echo $oneGroup->group_id; ?>]" value="<?php echo $oneGroup->group_id; ?>" title="<?php echo $oneGroup->group_name ?>"/><?php echo $oneGroup->group_name ?></label> <br/>
		<?php }
	}

	function onJoomSMSUserCreate($user){
		$this->_sendEmailToAdmin($user);
	}

	private function _sendEmailToAdmin($user){
		$config = JOOMSMS::config();
		$adminAddress = $config->get('admin_address');
		if(empty($adminAddress)) return;

		if(strpos($adminAddress, ',')){
			$recipient = explode(',', $adminAddress);
		}else $recipient = array($adminAddress);

		$mailer = JFactory::getMailer();
		$mailer->isHTML(true);

		$sender = array($config->get('config.mailfrom'), $config->get('config.fromname'));
		if(!empty($sender[0]) && !empty($sender[1])) $mailer->setSender($sender);

		$mailer->addRecipient($recipient);
		$subject = JText::_('SMS_ADMIN_NOTIFICATION_EMAIL_SUBJECT');
		$mailer->setSubject($subject);
		$body = JText::_('SMS_ADMIN_NOTIFICATION_EMAIL_BODY');

		foreach($user as $oneUserInformations => $value){
			if(strpos($body, '{'.$oneUserInformations.'}') !== false) $body = str_replace('{'.$oneUserInformations.'}', $value, $body);
		}

		$mailer->setBody($body);
		$send = $mailer->Send();
	}

	function onJoomSMSSubscribe($user_id, $groups){
		if(empty($groups[1])) return;
		$groups = $groups[1];

		$integrationFrom = 'joomsms';
		$integrationTo = '';

		$config = JOOMSMS::config();
		$db = JFactory::getDBO();
		$messageClass = JOOMSMS::get('class.message');

		if(empty($groups)) return false;

		$receiverField = $config->get('joomsms_field');
		if(empty($receiverField)) return;

		$allMessages = $messageClass->getAutoMessage('joomsmssubscription');
		if(empty($allMessages)) return false;

		$sendNow = 0;
		foreach($allMessages as $oneMessage){
			$commonLists = array_intersect($groups, $oneMessage->message_receiver['auto']['joomsmssubscription']['joomsmsgroups']);
			if(empty($commonLists)) continue;


			$joomsmsquery = JOOMSMS::get('class.joomsmsquery');
			$integrationTo = $oneMessage->message_receiver_table;
			$integration = JOOMSMS::getIntegration($integrationTo);
			$integration->initQuery($joomsmsquery);
			$joomsmsquery->addMessageFilters($oneMessage);
			$joomsmsquery->addUserFilters(array($user_id), $integrationFrom, $integrationTo);

			$senddate = strtotime('+'.intval($oneMessage->message_receiver['auto']['joomsmssubscription']['delay']['duration']).' '.$oneMessage->message_receiver['auto']['joomsmssubscription']['delay']['timevalue'], time());
			$querySelect = $joomsmsquery->getQuery(array($oneMessage->message_id.','.$integration->tableAlias.'.'.$integration->primaryField.','.$db->Quote($oneMessage->message_receiver_table).','.$senddate.',0,2'));


			$finalQuery = 'INSERT IGNORE INTO `#__joomsms_queue` (`queue_message_id`,`queue_receiver_id`,`queue_receiver_table`,`queue_senddate`,`queue_try`,`queue_priority`) '.$querySelect;
			$db->setQuery($finalQuery);
			$db->query();

			if(empty($oneMessage->message_receiver['auto']['joomsmssubscription']['delay']['duration'])) $sendNow = $oneMessage->message_id;
		}

		if(!empty($sendNow)){
			$queueHelper = JOOMSMS::get('helper.queue');
			$queueHelper->report = false;
			$queueHelper->message_id = $sendNow;
			$queueHelper->process();
		}
	}

	function onJoomSMSUnsubscribe($user_id, $groups){
		if(empty($user_id) || empty($groups[-1])) return;

		$UnsubscribeGroups = $groups[-1];
		$messageToDelete = array();
		$db = JFactory::getDBO();

		$messageClass = JOOMSMS::get('class.message');
		$allMessages = $messageClass->getAutoMessage('joomsmssubscription');
		if(empty($allMessages)) return;

		foreach($allMessages as $oneMessage){
			if(!empty($oneMessage->message_receiver['auto']['joomsmssubscription']['joomsmsgroups'])){
				foreach($oneMessage->message_receiver['auto']['joomsmssubscription']['joomsmsgroups'] as $oneGroup){
					if(in_array($oneGroup, $UnsubscribeGroups)) $messageToDelete[$oneMessage->message_id] = $oneMessage->message_id;
				}
			}
		}
		if(empty($messageToDelete)) return;

		JArrayHelper::toInteger($messageToDelete);

		$db->setQuery('DELETE  FROM '.JOOMSMS::table('queue').' WHERE `queue_receiver_id` = '.intval($user_id).' AND `queue_message_id` IN ('.implode(',', $messageToDelete).')');
		$db->query();
	}



	public function onJoomSMSSaveMessage($oldMsg, $newMsg){
		if(empty($newMsg['message_type']) || $newMsg['message_type'] != 'auto' || empty($newMsg['message_autotype'])) return;
		if($newMsg['message_autotype'] != 'joomsmssubscription') return;
		$toggleHelper = JOOMSMS::get('helper.toggle');
		$db = JFactory::getDBO();

		if(!isset($newMsg['message_receiver']['auto']['joomsmssubscription']['delay'])) return;
		$newMsgDelay = $newMsg['message_receiver']['auto']['joomsmssubscription']['delay'];

		if(empty($newMsg['message_receiver']['auto']['joomsmssubscription']['joomsmsgroups'])) return;


		if(empty($oldMsg->message_receiver['auto']['joomsmssubscription'])){

			$delay = strtotime($newMsgDelay['duration'].' '.$newMsgDelay['timevalue']) - time();

			$joomsmsquery = $this->_getAcyQuery($oldMsg->message_id, $delay);
			$nbUser = $joomsmsquery->count($newMsg['message_receiver_table']);
			if(empty($nbUser)) return;

			$timeDisplayed = JOOMSMS::getDate(time() - $delay);

			$joomsmsquery = $this->_getAcyQuery($oldMsg->message_id, '');
			$nbUserAll = $joomsmsquery->count($newMsg['message_receiver_table']);

			$text = $toggleHelper->toggleText('plgtrigger', $oldMsg->message_id.'_delay', '', '&function=onJoomSMSAutoMsgAdd&plg=joomsms&plgtype=joomsms&delay=1&msgId='.$oldMsg->message_id, JText::sprintf('SMS_ADD_NEW_MESSAGE_QUEUE_SUBSCRIBED_AFTER', $nbUser, $timeDisplayed));
			$text .= '<br />';
			$text .= $toggleHelper->toggleText('plgtrigger', $oldMsg->message_id, '', '&function=onJoomSMSAutoMsgAdd&plg=joomsms&plgtype=joomsms&msgId='.$oldMsg->message_id, JText::sprintf('SMS_ADD_NEW_MESSAGE_QUEUE_SUBSCRIBED_ALL', $nbUserAll));

			JOOMSMS::enqueueMessage($text, 'notice');
			return;
		}

		if(!isset($oldMsg->message_receiver['auto']['joomsmssubscription']['delay'])) return;
		$oldMsgDelay = $oldMsg->message_receiver['auto']['joomsmssubscription']['delay'];

		if(($oldMsgDelay['duration'] !== $newMsgDelay['duration']) || ($oldMsgDelay['timevalue'] !== $newMsgDelay['timevalue'])){
			$difference = strtotime($newMsgDelay['duration'].' '.$newMsgDelay['timevalue']) - strtotime($oldMsgDelay['duration'].' '.$oldMsgDelay['timevalue']);
			$text = JText::_('SMS_MESSAGE_CHANGED_DELAY_INFORMED');
			$text .= ' '.$toggleHelper->toggleText('plgtrigger', $oldMsg->message_id, '', '&function=onJoomSMSAutoMsgUpdate&plg=joomsms&plgtype=joomsms&difference='.$difference.'&msgId='.$oldMsg->message_id, JText::_('SMS_MESSAGE_CHANGED_DELAY'));

			JOOMSMS::enqueueMessage($text, 'notice');
		}
	}

	private function _getAcyQuery($messageId, $msgDelay){
		$messageClass = JOOMSMS::get('class.message');
		$message = $messageClass->get($messageId);

		$delayIsPresent = JRequest::getInt('delay', '');

		$integration = JOOMSMS::getIntegration($message->message_receiver_table);

		$joomsmsquery = JOOMSMS::get('class.joomsmsquery');
		$integration->initQuery($joomsmsquery);
		$joomsmsquery->addMessageFilters($message);
		$joomsmsquery->join['groupuser'] = ' JOIN #__joomsms_groupuser as groupuser ON joomsmsusers.user_id = groupuser.groupuser_user_id';

		JArrayHelper::toInteger($message->message_receiver['auto']['joomsmssubscription']['joomsmsgroups']);

		$joomsmsquery->where[] = ' groupuser.groupuser_status = 1 AND groupuser_group_id IN ('.implode(',', $message->message_receiver['auto']['joomsmssubscription']['joomsmsgroups']).')';
		if($delayIsPresent) $joomsmsquery->where[] = 'groupuser.`groupuser_subdate` >'.(time() - $msgDelay);
		return $joomsmsquery;
	}

	public function ajax_onJoomSMSAutoMsgUpdate(){

		$messageId = JRequest::getInt('msgId', '');
		if(empty($messageId)) return;

		$diff = JRequest::getInt('difference', '');
		if(empty($diff)) return;

		$queueClass = JOOMSMS::get('class.queue');
		$queueClass->plgQueueUpdateSenddate($messageId, $diff);
	}

	public function ajax_onJoomSMSAutoMsgAdd(){

		$messageId = JRequest::getInt('msgId', '');
		if(empty($messageId)) return;
		$delay = JRequest::getInt('delay', '');

		$db = JFactory::getDBO();
		$messageClass = JOOMSMS::get('class.message');
		$newMessage = $messageClass->get($messageId);
		if(empty($newMessage->message_id)){
			echo 'Could not load messageId '.$messageId;
			exit;
		}

		$integrationName = "";
		$integration = JOOMSMS::getIntegration($newMessage->message_receiver_table);


		$senddate = strtotime($newMessage->message_receiver['auto']['joomsmssubscription']['delay']['duration'].' '.$newMessage->message_receiver['auto']['joomsmssubscription']['delay']['timevalue']) - time();

		$integration = JOOMSMS::getIntegration($newMessage->message_receiver_table);
		$joomsmsquery = $this->_getAcyQuery($messageId, $senddate);
		$querySelect = $joomsmsquery->getQuery(array($newMessage->message_id.','.$integration->tableAlias.'.'.$integration->primaryField.','.$db->Quote($newMessage->message_receiver_table).', groupuser.`groupuser_subdate` +'.$senddate.',0,2'));

		$finalQuery = 'INSERT IGNORE INTO `#__joomsms_queue` (`queue_message_id`,`queue_receiver_id`,`queue_receiver_table`,`queue_senddate`,`queue_try`,`queue_priority`) '.$querySelect;
		$db->setQuery($finalQuery);
		$db->query();
		$nbinserted = $db->getAffectedRows();

		echo JText::sprintf('SMS_ADDED_QUEUE', $nbinserted);
		exit;
	}


	function onJOOMSMSDisplayFiltersSimpleMessage($componentName, &$filters){

		$app = JFactory::getApplication();
		$config = JOOMSMS::config();
		$allowCustomerManagement = $config->get('allowCustomersManagement');
		$displayToCustomers = $this->params->get('displayToCustomers', '1');
		if($allowCustomerManagement && empty($displayToCustomers) && !$app->isAdmin()) return;

		if(!$app->isAdmin()){
			$helperPlugin = JOOMSMS::get('helper.plugins');
			if(!$helperPlugin->allowSendByGroups('joomsmsgroup')) return;
		}

		$newFilter = new stdClass();
		$newFilter->name = JText::sprintf('SMS_X_GROUPS', 'JoomSMS');
		$filters['communityFilters']['joomsmsGroups'] = $newFilter;
	}

	function onJOOMSMSDisplayFilterParams_joomsmsGroups($message){
		$app = JFactory::getApplication();
		$db = JFactory::getDBO();
		$config = JOOMSMS::config();

		$my = JFactory::getUser();

			jimport('joomla.access.access');
			$myJoomlaGroups = JAccess::getGroupsByUser($my->id, false);

		$extraCondition = '';

		if(!$app->isAdmin()){
			$frontEndFilters = $config->get('frontEndFilters');
			if(is_string($frontEndFilters)) $frontEndFilters = unserialize($frontEndFilters);

			$availableFrontGroupFilters = array();
			foreach($frontEndFilters as $oneCondition){
				if($oneCondition['filters'] != 'joomsmsgroup') continue;
				if(empty($oneCondition['filterDetails']) || empty($oneCondition['filterDetails']['joomsmsgroup'])) continue;
				if($oneCondition['typeDetails'] != 'all' && !in_array($oneCondition['typeDetails'], $myJoomlaGroups)) continue;
				$availableFrontGroupFilters += $oneCondition['filterDetails']['joomsmsgroup'];
			}
			if(empty($availableFrontGroupFilters)) return;

			if(in_array('userowngroups', $availableFrontGroupFilters)){
				$groupClass = JOOMSMS::get('class.group');
				$myOwnGroups = $groupClass->getFrontendGroups('group_id');
				if(!empty($myOwnGroups)){
					foreach($myOwnGroups as $oneGroup){
						$availableFrontGroupFilters[] = $oneGroup->group_id;
					}
				}
			}
			JArrayHelper::toInteger($availableFrontGroupFilters);
			$extraCondition = ' WHERE group_id IN ('.implode(',', $availableFrontGroupFilters).')';
		}

		$query = 'SELECT group_name, group_id FROM #__joomsms_group '.$extraCondition.' ORDER BY group_ordering ASC';
		$db->setQuery($query);
		$groups = $db->loadObjectList();

		echo JText::sprintf('SMS_SEND_X_GROUPS', 'JoomSMS').' : <br />';
		foreach($groups as $oneGroup){
			if(!$app->isAdmin()){
				if(!in_array($oneGroup->group_id, $availableFrontGroupFilters)) continue;
			} ?>
			<label><input type="checkbox" name="data[message][message_receiver][standard][joomsms][joomsmsGroups][<?php echo $oneGroup->group_id; ?>]" value="<?php echo $oneGroup->group_id ?>" title="<?php echo $oneGroup->group_name ?>"/> <?php echo $oneGroup->group_name ?></label><br/>
		<?php }
	}

	function onJOOMSMSSelectData_joomsmsGroups(&$joomsmsquery, $message){
		if(empty($message->message_receiver['standard']['joomsms']['joomsmsGroups'])) return;
		if(!isset($joomsmsquery->join['joomsmsusers']) && $message->message_receiver_table != 'joomsms') $joomsmsquery->join['joomsmsusers'] = 'JOIN #__joomsms_user AS joomsmsusers ON joomsmsusers.user_joomid = joomusers.id';
		$joomsmsquery->join['joomsmsgroupuser'] = 'JOIN #__joomsms_groupuser as joomsmsgroupuser ON joomsmsgroupuser.groupuser_user_id = joomsmsusers.user_id ';

		JArrayHelper::toInteger($message->message_receiver['standard']['joomsms']['joomsmsGroups']);

		$joomsmsquery->where[] = ' joomsmsgroupuser.groupuser_group_id IN ('.implode(',', ($message->message_receiver['standard']['joomsms']['joomsmsGroups'])).') AND joomsmsgroupuser.groupuser_status = 1';
	}

	public function onJOOMSMSdisplayAuthorizedFilters(&$authorizedFilters, $type){
		$newType = new stdClass();
		$newType->name = JText::_('SMS_JOOMSMS_GROUP');
		$authorizedFilters['joomsmsgroup'] = $newType;
	}

	public function onJOOMSMSdisplayAuthorizedFilters_joomsmsgroup(&$authorizedFiltersSelection, $conditionNumber){
		$db = JFactory::getDBO();
		$db->setQuery('SELECT group_id, group_name FROM #__joomsms_group');
		$joomSMSGroups = $db->loadObjectList();

		if(empty($joomSMSGroups)) return;

		$ownGroupsObject = new stdClass();
		$ownGroupsObject->group_id = 'userowngroups';
		$ownGroupsObject->group_name = JText::_('SMS_USER_OWN_GROUPS');
		array_unshift($joomSMSGroups, $ownGroupsObject);

		$config = JOOMSMS::config();
		$frontEndFilters = $config->get('frontEndFilters');
		if(is_string($frontEndFilters)) $frontEndFilters = unserialize($frontEndFilters);

		$result = '<br />';
		foreach($joomSMSGroups as $oneGroup){
			if(!empty($frontEndFilters[$conditionNumber]['filterDetails']['joomsmsgroup']) && in_array($oneGroup->group_id, $frontEndFilters[$conditionNumber]['filterDetails']['joomsmsgroup'])){
				$checked = 'checked="checked"';
			}else $checked = '';
			$result .= '<label><input type="checkbox" name="config[frontEndFilters]['.$conditionNumber.'][filterDetails][joomsmsgroup]['.$oneGroup->group_id.']" value="'.$oneGroup->group_id.'" '.$checked.' title= "'.$oneGroup->group_name.'"/> '.$oneGroup->group_name.'</label><br />';
		}
		$authorizedFiltersSelection .= '<span id="'.$conditionNumber.'_joomsmsAuthorizedFilterDetails">'.$result.'</span>';
	}

	public function onJOOMSMSdisplayRequiredFilters(&$requiredFilters){
		$newType = new stdClass();
		$newType->name = JText::_('SMS_JOOMSMS_GROUP');
		$requiredFilters['joomsmsgroup'] = $newType;
	}

	public function onJoomSMSAllowSend_joomsmsgroup($messageReceiver, &$answer){
		if(empty($messageReceiver['standard']['joomsms']['joomsmsGroups'])){
			$answer->msg = JText::_('SMS_PLEASE_SELECT_GROUP');
			$answer->result = false;
			return;
		}
		$answer->result = true;
	}
}//endclass
