<?php
/**
 * @package	JoomSMS for Joomla!
 * @version	1.0
 * @author	JoomBoost
 * @copyright	(C) 2013-2020 JoomBoost. All rights reserved.
 * @license	GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php

class plgJoomsmsJoomsmsUser extends JPlugin{

	var $sendervalues = array();

	function __construct(&$subject, $config){
		if(!file_exists(rtrim(JPATH_ADMINISTRATOR, DIRECTORY_SEPARATOR).DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_joomsms')) return;
		parent::__construct($subject, $config);
		if(!isset ($this->params)){
			$plugin = JPluginHelper::getPlugin('joomsms', 'joomsmsuser');
			$this->params = new joomsmsParameter($plugin->params);
		}
	}




	function onJOOMSMSGetTags(&$tags){

		$tags['communityTags']['joomsms'] = new stdClass();
		$tags['communityTags']['joomsms']->name = JText::sprintf('SMS_X_USER_INFO', 'JoomSMS');
		$tableFields = joomsms_getColumns('#__joomsms_user');

		$tags['communityTags']['joomsms']->content = '<table class="joomsms_table"><tbody>';
		$k = 0;
		foreach($tableFields as $oneField => $fieldType){
			$tags['communityTags']['joomsms']->content .= '<tr style="cursor:pointer" onclick="insertTag(\'{joomsms:'.$oneField.'}\')" class="row'.$k.'"><td>'.$oneField.'</td></tr>';
			$k = 1 - $k;
		}
		$tags['communityTags']['joomsms']->content .= '<tr style="cursor:pointer" onclick="insertTag(\'{joomsms:message_id}\')" class="row'.$k.'"><td>'.JText::_('SMS_MESSAGE_ID').'</td></tr>';
		$tags['communityTags']['joomsms']->content .= '</tbody></table>';
	}


	function onJOOMSMSReplaceUserTags(&$message, &$user, $send = true){
		$tagKey = JText::_('SMS_USER_TAG_KEY');
		if($tagKey == 'SMS_USER_TAG_KEY') $tagKey = 'joomsms';

		$helperPlugin = JOOMSMS::get('helper.plugins');
		$tags = $helperPlugin->extractTags($message, $tagKey);


		if(!isset($user->joomsms)){
			$db = JFactory::getDBO();
			if(!empty($user->joomla->id)){
				$query = 'SELECT * FROM #__joomsms_user WHERE user_joomid = '.intval($user->joomla->id);
				$db->setQuery($query);
				$user->joomsms = $db->loadObject();
			}
		}

		foreach($tags as $oneString => $oneObject){
			if(isset($user->joomsms->{$oneObject->id}) && strlen($user->joomsms->{$oneObject->id}) > 0){
				$tags[$oneString] = $user->joomsms->{$oneObject->id};
			}else if((isset($message->{$oneObject->id}) && strlen($message->{$oneObject->id}) > 0)){
				$tags[$oneString] = $message->{$oneObject->id};
			}else $tags[$oneString] = $oneObject->default;

			if($oneObject->id == 'user_activationcode'){
				if(!empty($oneObject->subType)){
					if(is_string($tags[$oneString])) $tags[$oneString] = unserialize($tags[$oneString]);
					if(!empty($tags[$oneString][$oneObject->subType])){
						$tags[$oneString] = $tags[$oneString][$oneObject->subType];
					}else $tags[$oneString] = 'Error subType '.$oneObject->subType.'. Use '.implode(' or ', array_keys($tags[$oneString]));
				}else{
					if(is_string($tags[$oneString])) $tags[$oneString] = unserialize($tags[$oneString]);
					if(is_array($tags[$oneString])) $tags[$oneString] = reset($tags[$oneString]);
				}
			}
			$helperPlugin->formatString($tags[$oneString], $oneObject);
		}
		$message->message_body = str_replace(array_keys($tags), $tags, $message->message_body);
	}





	function onJOOMSMSDisplayFiltersSimpleMessage($componentName, &$filters){
		$app = JFactory::getApplication();
		$config = JOOMSMS::config();
		$allowCustomerManagement = $config->get('allowCustomersManagement');
		$displayToCustomers = $this->params->get('displayToCustomers', '1');
		if($allowCustomerManagement && empty($displayToCustomers) && !$app->isAdmin()) return;

		$db = JFactory::getDBO();

		$helperPlugin = JOOMSMS::get('helper.plugins');

		$filter = new stdClass();
		$filter->name = JText::sprintf('SMS_INTEGRATION_FIELDS', 'JoomSMS');
		if($app->isAdmin() || (!$app->isAdmin() && $helperPlugin->allowSendByGroups('joomsmsfields'))) $filters['communityFilters']['joomsmsField'] = $filter;

		$secondFilter = new stdClass();
		$secondFilter->name = JText::sprintf('SMS_INTEGRATION_FIELDS', 'JoomSMS Statistics');
		if($app->isAdmin() || (!$app->isAdmin() && $helperPlugin->allowSendByGroups('joomsmsstatisticsfields'))) $filters['communityFilters']['joomsmsStatisticsField'] = $secondFilter;
	}


	function onJOOMSMSDisplayFilterParams_joomsmsStatisticsfield($message){

		$field = array();
		$field[] = JHTML::_('select.option', '', ' - - - ');


		$field[] = JHTML::_('select.option', '0', JText::_('SMS_STATUS_FAILED'));
		$field[] = JHTML::_('select.option', '1', JText::_('SMS_STATUS_1'));
		$field[] = JHTML::_('select.option', 'nevertried', JText::_('SMS_NEVER_TRIED_TO_SEND'));
		$field[] = JHTML::_('select.option', '<OPTGROUP>', JText::_('SMS_DELIVERY_STATUS'));
		$field[] = JHTML::_('select.option', '2', JText::_('SMS_STATUS_2'));
		$field[] = JHTML::_('select.option', '3', JText::_('SMS_STATUS_3'));
		$field[] = JHTML::_('select.option', '4', JText::_('SMS_STATUS_4'));
		$field[] = JHTML::_('select.option', '5', JText::_('SMS_STATUS_5'));
		$field[] = JHTML::_('select.option', '</OPTGROUP>');
		$field[] = JHTML::_('select.option', '<OPTGROUP>', JText::_('SMS_DELIVERY_FAILURE_STATUS'));
		$field[] = JHTML::_('select.option', '-1', JText::_('SMS_STATUS_M1'));
		$field[] = JHTML::_('select.option', '-2', JText::_('SMS_STATUS_M2'));
		$field[] = JHTML::_('select.option', '-3', JText::_('SMS_STATUS_M3'));
		$field[] = JHTML::_('select.option', '-99', JText::_('SMS_STATUS_M99'));
		$field[] = JHTML::_('select.option', '</OPTGROUP>');

		$db = JFactory::getDBO();
		$db->setQuery("SELECT `message_id`,CONCAT(`message_subject`,' ( ID : ',`message_id`,' )') AS value FROM `#__joomsms_message` WHERE `message_type` NOT IN ('answer') ORDER BY `message_subject` ASC ");
		$allMessages = $db->loadObjectList();
		$element = new stdClass();
		$element->message_id = 0;
		$element->value = JText::_('SMS_AT_LEAST_ONE_MESSAGE');
		array_unshift($allMessages, $element);

		$operators = JOOMSMS::get('type.operators');

		$relation = array();
		$relation[] = JHTML::_('select.option', 'AND', JText::_('SMS_AND'));
		$relation[] = JHTML::_('select.option', 'OR', JText::_('SMS_OR'));

		?>
		<span id="countresult_joomsmsStatisticsfield"></span>
		<?php
		for($i = 0; $i < 5; $i++){
			$operators->extra = 'onchange="countresults(\'joomsmsStatisticsfield\')"';
			$return = '<div id="filter'.$i.'joomsmsStatisticsfield">'.JHTML::_('select.genericlist', $field, "data[message][message_receiver][standard][joomsms][joomsmsStatisticsfield][".$i."][status]", 'onchange="countresults(\'joomsmsStatisticsfield\')" class="inputbox" size="1" style=""', 'value', 'text');
			$return .= JHTML::_('select.genericlist', $allMessages, "data[message][message_receiver][standard][joomsms][joomsmsStatisticsfield][".$i."][message_id]", 'onchange="countresults(\'joomsmsStatisticsfield\')" class="inputbox" style="width:auto;" size="1"', 'message_id', 'value').'<br />';
			if($i != 4) $return .= JHTML::_('select.genericlist', $relation, "data[message][message_receiver][standard][joomsms][joomsmsStatisticsfield][".$i."][relation]", 'onchange="countresults(\'joomsmsStatisticsfield\')" class="inputbox" style="width:100px;" size="1"', 'value', 'text');
			echo $return;
		}
	}

	function onJOOMSMSSelectData_joomsmsStatisticsfield(&$joomsmsquery, $message){
		if(!empty($message->message_receiver_table)){
			$integration = JOOMSMS::getIntegration($message->message_receiver_table);
		}else $integration = JOOMSMS::getIntegration();

		if(empty($joomsmsquery->from)) $integration->initQuery($joomsmsquery);
		if(!isset($message->message_receiver['standard']['joomsms']['joomsmsStatisticsfield'])) return;


		$addCondition = '';
		$whereConditions = '';
		$nbJoin = 0;

		foreach($message->message_receiver['standard']['joomsms']['joomsmsStatisticsfield'] as $filterNumber => $oneFilter){
			if($oneFilter['status'] == '') continue;
			if(!empty($addCondition)) $whereConditions = '('.$whereConditions.') '.$addCondition.' ';
			if(!empty($oneFilter['relation'])){
				$addCondition = $oneFilter['relation'];
			}else  $addCondition = 'AND';

			$joomsmsquery->join['joomsmsstatistics'.$nbJoin] = 'LEFT JOIN #__joomsms_statsdetails AS joomsmsstatsdetails'.$nbJoin.' ON '.$integration->tableAlias.'.'.$integration->primaryField.' = joomsmsstatsdetails'.$nbJoin.'.statsdetails_receiver_id ';

			if($oneFilter['status'] == 'nevertried'){
				$joomsmsquery->join['joomsmsstatistics'.$nbJoin] .= ' AND joomsmsstatsdetails'.$nbJoin.'.statsdetails_message_id = '.intval($oneFilter['message_id']);
				$whereConditions .= 'joomsmsstatsdetails'.$nbJoin.'.statsdetails_status IS NULL';
			}else if($oneFilter['status'] == '0'){
				$whereConditions .= 'joomsmsstatsdetails'.$nbJoin.'.statsdetails_status <= 0';
			}else    $whereConditions .= 'joomsmsstatsdetails'.$nbJoin.'.statsdetails_status = '.intval($oneFilter['status']);

			if(!empty($oneFilter['message_id']) && $oneFilter['status'] != 'nevertried') $whereConditions .= ' AND joomsmsstatsdetails'.$nbJoin.'.statsdetails_message_id = '.intval($oneFilter['message_id']);
			$nbJoin++;
		}
		if(!empty($whereConditions)) $joomsmsquery->where[] = $whereConditions;
	}


	function onJOOMSMSDisplayFilterParams_joomsmsField($message){
		$fields = joomsms_getColumns('#__joomsms_user');
		if(empty($fields)) return;

		$field = array();
		$field[] = JHTML::_('select.option', '', ' - - - ');
		foreach($fields as $oneField => $fieldType){
			$field[] = JHTML::_('select.option', $oneField, $oneField);
		}

		$relation = array();
		$relation[] = JHTML::_('select.option', 'AND', JText::_('SMS_AND'));
		$relation[] = JHTML::_('select.option', 'OR', JText::_('SMS_OR'));

		$operators = JOOMSMS::get('type.operators');

		?>
		<span id="countresult_joomsmsField"></span>
		<?php
		for($i = 0; $i < 5; $i++){
			$operators->extra = 'onchange="countresults(\'joomsmsField\')"';
			$return = '<div id="filter'.$i.'joomsmsfield">'.JHTML::_('select.genericlist', $field, "data[message][message_receiver][standard][joomsms][joomsmsField][".$i."][map]", 'onchange="countresults(\'joomsmsField\')" class="inputbox" size="1"', 'value', 'text');
			$return .= ' '.$operators->display("data[message][message_receiver][standard][joomsms][joomsmsField][".$i."][operator]").' <input onchange="countresults(\'joomsmsField\')" class="inputbox" type="text" name="data[message][message_receiver][standard][joomsms][joomsmsField]['.$i.'][value]" style="width:200px" value=""></div>';
			if($i != 4) $return .= JHTML::_('select.genericlist', $relation, "data[message][message_receiver][standard][joomsms][joomsmsField][".$i."][relation]", 'onchange="countresults(\'joomsmsField\')" class="inputbox" style="width:100px;" size="1"', 'value', 'text');
			echo $return;
		}
	}

	function onJOOMSMSSelectData_joomsmsField(&$joomsmsquery, $message){

		if(!empty($message->message_receiver_table)){
			$integration = JOOMSMS::getIntegration($message->message_receiver_table);
		}else $integration = JOOMSMS::getIntegration();

		if(empty($joomsmsquery->from)) $integration->initQuery($joomsmsquery);
		if(!isset($message->message_receiver['standard']['joomsms']['joomsmsField'])) return;
		if(!isset($joomsmsquery->join['joomsmsusers']) && $integration->componentName != 'joomsms') $joomsmsquery->join['joomsmsusers'] = 'LEFT JOIN #__joomsms_user AS joomsmsusers ON joomusers.id = joomsmsusers.user_joomid ';
		$addCondition = '';
		$whereConditions = '';
		foreach($message->message_receiver['standard']['joomsms']['joomsmsField'] as $filterNumber => $oneFilter){
			if(empty($oneFilter['map'])) continue;
			if(!empty($addCondition)) $whereConditions = '('.$whereConditions.') '.$addCondition.' ';
			if(!empty($oneFilter['relation'])){
				$addCondition = $oneFilter['relation'];
			}else  $addCondition = 'AND';

			$timeTag = false;
			$replace = array('{year}', '{month}', '{weekday}', '{day}');
			foreach($replace as $oneReplace){
				if(strpos($oneFilter['value'], $oneReplace) !== false) $timeTag = true;
			}

			if(strpos($oneFilter['value'], '{time}') !== false) $oneFilter['value'] = JOOMSMS::replaceDate($oneFilter['value']);
			if($timeTag){
				$replaceBy = array(date('Y'), date('m'), date('N'), date('d'));
				$oneFilter['value'] = str_replace($replace, $replaceBy, $oneFilter['value']);
			}

			$whereConditions .= $joomsmsquery->convertQuery('joomsmsusers', $oneFilter['map'], $oneFilter['operator'], $oneFilter['value'], '');
		}
		if(!empty($whereConditions)) $joomsmsquery->where[] = $whereConditions;
	}

	public function onJOOMSMSdisplayAuthorizedFilters(&$authorizedFilters, $type){
		$newType = new stdClass();
		$newType->name = JText::sprintf('SMS_INTEGRATION_FIELDS', 'JoomSMS');
		$authorizedFilters['joomsmsfields'] = $newType;

		$newType = new stdClass();
		$newType->name = JText::sprintf('SMS_INTEGRATION_FIELDS', 'JoomSMS Statistics');
		$authorizedFilters['joomsmsstatisticsfields'] = $newType;
	}

	public function onJOOMSMSdisplayAuthorizedFilters_joomsmsfields(&$authorizedFiltersSelection, $conditionNumber){
		$authorizedFiltersSelection .= '<span id="'.$conditionNumber.'_joomsmsAuthorizedFilterDetails"></span>';
	}

}//endclass
