<?php
/**
 * @package			JoomSMS
 * @copyright		Copyright (C) 2013-2020 JoomBoost., Ltd. All Rights Reserved.
 * @license			GNU General Public License version 2 or later; see LICENSE.txt
 * @author			JoomBoost
 * @website			https://www.joomboost.com
 */

# No Permission
defined('_JEXEC') or die();

class plgSystemJoomsms extends JPlugin {


    public function onInstallerBeforePackageDownload(&$url, &$headers) {

        $uri = JUri::getInstance($url);

        // I don't care about download URLs not coming from our site
        $host = $uri->getHost();

        if ($host != 'www.joomboost.com') {
            return true;
        }

        // Get the download ID
        $params = JComponentHelper::getParams('com_joomsms');
        $dlid = $params->get('downloadid', '');

        // If the download ID is invalid, return without any further action
        if (!preg_match('/^([0-9]{1,}:)?[0-9a-f]{32}$/i', $dlid)) {
            return true;
        }

        // Append the Download ID to the download URL
        if (!empty($dlid)) {
            $uri->setVar('dlid', $dlid);
            $url = $uri->toString();
        }

        return true;
    }
}
